"use strict";
var __esDecorate = (this && this.__esDecorate) || function (ctor, descriptorIn, decorators, contextIn, initializers, extraInitializers) {
    function accept(f) { if (f !== void 0 && typeof f !== "function") throw new TypeError("Function expected"); return f; }
    var kind = contextIn.kind, key = kind === "getter" ? "get" : kind === "setter" ? "set" : "value";
    var target = !descriptorIn && ctor ? contextIn["static"] ? ctor : ctor.prototype : null;
    var descriptor = descriptorIn || (target ? Object.getOwnPropertyDescriptor(target, contextIn.name) : {});
    var _, done = false;
    for (var i = decorators.length - 1; i >= 0; i--) {
        var context = {};
        for (var p in contextIn) context[p] = p === "access" ? {} : contextIn[p];
        for (var p in contextIn.access) context.access[p] = contextIn.access[p];
        context.addInitializer = function (f) { if (done) throw new TypeError("Cannot add initializers after decoration has completed"); extraInitializers.push(accept(f || null)); };
        var result = (0, decorators[i])(kind === "accessor" ? { get: descriptor.get, set: descriptor.set } : descriptor[key], context);
        if (kind === "accessor") {
            if (result === void 0) continue;
            if (result === null || typeof result !== "object") throw new TypeError("Object expected");
            if (_ = accept(result.get)) descriptor.get = _;
            if (_ = accept(result.set)) descriptor.set = _;
            if (_ = accept(result.init)) initializers.unshift(_);
        }
        else if (_ = accept(result)) {
            if (kind === "field") initializers.unshift(_);
            else descriptor[key] = _;
        }
    }
    if (target) Object.defineProperty(target, contextIn.name, descriptor);
    done = true;
};
var __runInitializers = (this && this.__runInitializers) || function (thisArg, initializers, value) {
    var useValue = arguments.length > 2;
    for (var i = 0; i < initializers.length; i++) {
        value = useValue ? initializers[i].call(thisArg, value) : initializers[i].call(thisArg);
    }
    return useValue ? value : void 0;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g = Object.create((typeof Iterator === "function" ? Iterator : Object).prototype);
    return g.next = verb(0), g["throw"] = verb(1), g["return"] = verb(2), typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __setFunctionName = (this && this.__setFunctionName) || function (f, name, prefix) {
    if (typeof name === "symbol") name = name.description ? "[".concat(name.description, "]") : "";
    return Object.defineProperty(f, "name", { configurable: true, value: prefix ? "".concat(prefix, " ", name) : name });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.IndyVdrApi = void 0;
var anoncreds_1 = require("@credo-ts/anoncreds");
var core_1 = require("@credo-ts/core");
var indy_vdr_shared_1 = require("@hyperledger/indy-vdr-shared");
var didIndyUtil_1 = require("./dids/didIndyUtil");
var error_1 = require("./error");
var sign_1 = require("./utils/sign");
var IndyVdrApi = function () {
    var _classDecorators = [(0, core_1.injectable)()];
    var _classDescriptor;
    var _classExtraInitializers = [];
    var _classThis;
    var IndyVdrApi = _classThis = /** @class */ (function () {
        function IndyVdrApi_1(agentContext, indyVdrPoolService) {
            this.agentContext = agentContext;
            this.indyVdrPoolService = indyVdrPoolService;
        }
        IndyVdrApi_1.prototype.multiSignRequest = function (request, signingKey, identifier) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    return [2 /*return*/, (0, sign_1.multiSignRequest)(this.agentContext, request, signingKey, identifier)];
                });
            });
        };
        IndyVdrApi_1.prototype.signRequest = function (request, submitterDid) {
            return __awaiter(this, void 0, void 0, function () {
                var pool;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.indyVdrPoolService.getPoolForDid(this.agentContext, submitterDid)];
                        case 1:
                            pool = (_a.sent()).pool;
                            return [2 /*return*/, (0, sign_1.signRequest)(this.agentContext, pool, request, submitterDid)];
                    }
                });
            });
        };
        /**
         * This method refreshes the pool connection and ensures the pool is up to date with the ledger.
         */
        IndyVdrApi_1.prototype.refreshPoolConnections = function () {
            return this.indyVdrPoolService.refreshPoolConnections();
        };
        /**
         * This method gets the updated transactions of the pool.
         * @returns The transactions of the pool ledger
         */
        IndyVdrApi_1.prototype.getAllPoolTransactions = function () {
            return this.indyVdrPoolService.getAllPoolTransactions();
        };
        /**
         * This method endorses a transaction. The transaction can be either a string or a JSON object.
         * If the transaction has a signature, it means the transaction was created by another author and will be endorsed.
         * This requires the `endorser` on the transaction to be equal to the unqualified variant of the `endorserDid`.
         *
         * If the transaction is not signed, we have a special case where the endorser will author the transaction.
         * This is required when a new did is created, as the author and the endorser did must already exist on the ledger.
         * In this case, the author did (`identifier`) must be equal to the unqualified identifier of the `endorserDid`.
         * @param transaction the transaction body to be endorsed
         * @param endorserDid the did of the endorser
         * @returns An endorsed transaction
         */
        IndyVdrApi_1.prototype.endorseTransaction = function (transaction, endorserDid) {
            return __awaiter(this, void 0, void 0, function () {
                var endorserSigningKey, namespaceIdentifier, request, endorsedTransaction, txBody;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, (0, didIndyUtil_1.verificationKeyForIndyDid)(this.agentContext, endorserDid)];
                        case 1:
                            endorserSigningKey = _a.sent();
                            namespaceIdentifier = (0, anoncreds_1.parseIndyDid)(endorserDid).namespaceIdentifier;
                            request = new indy_vdr_shared_1.CustomRequest({ customRequest: transaction });
                            txBody = typeof transaction === 'string' ? JSON.parse(transaction) : transaction;
                            if (!txBody.signature) return [3 /*break*/, 3];
                            if (txBody.endorser !== namespaceIdentifier)
                                throw new error_1.IndyVdrError('Submitter does not match Endorser');
                            return [4 /*yield*/, this.multiSignRequest(request, endorserSigningKey, namespaceIdentifier)];
                        case 2:
                            endorsedTransaction = _a.sent();
                            return [3 /*break*/, 5];
                        case 3:
                            if (txBody.identifier !== namespaceIdentifier)
                                throw new error_1.IndyVdrError('Submitter does not match identifier');
                            return [4 /*yield*/, this.signRequest(request, endorserDid)];
                        case 4:
                            endorsedTransaction = _a.sent();
                            _a.label = 5;
                        case 5: return [2 /*return*/, endorsedTransaction.body];
                    }
                });
            });
        };
        return IndyVdrApi_1;
    }());
    __setFunctionName(_classThis, "IndyVdrApi");
    (function () {
        var _metadata = typeof Symbol === "function" && Symbol.metadata ? Object.create(null) : void 0;
        __esDecorate(null, _classDescriptor = { value: _classThis }, _classDecorators, { kind: "class", name: _classThis.name, metadata: _metadata }, null, _classExtraInitializers);
        IndyVdrApi = _classThis = _classDescriptor.value;
        if (_metadata) Object.defineProperty(_classThis, Symbol.metadata, { enumerable: true, configurable: true, writable: true, value: _metadata });
        __runInitializers(_classThis, _classExtraInitializers);
    })();
    return IndyVdrApi = _classThis;
}();
exports.IndyVdrApi = IndyVdrApi;
