"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g = Object.create((typeof Iterator === "function" ? Iterator : Object).prototype);
    return g.next = verb(0), g["throw"] = verb(1), g["return"] = verb(2), typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.IndyVdrAnonCredsRegistry = void 0;
var anoncreds_1 = require("@credo-ts/anoncreds");
var core_1 = require("@credo-ts/core");
var indy_vdr_shared_1 = require("@hyperledger/indy-vdr-shared");
var didIndyUtil_1 = require("../dids/didIndyUtil");
var pool_1 = require("../pool");
var sign_1 = require("../utils/sign");
var identifiers_1 = require("./utils/identifiers");
var transform_1 = require("./utils/transform");
var IndyVdrAnonCredsRegistry = /** @class */ (function () {
    function IndyVdrAnonCredsRegistry() {
        this.methodName = 'indy';
        this.supportedIdentifier = identifiers_1.indyVdrAnonCredsRegistryIdentifierRegex;
    }
    IndyVdrAnonCredsRegistry.prototype.getSchema = function (agentContext, schemaId) {
        return __awaiter(this, void 0, void 0, function () {
            var indyVdrPoolService, _a, did, namespaceIdentifier, schemaName, schemaVersion, pool, legacySchemaId, request, response, error_1;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _b.trys.push([0, 3, , 4]);
                        indyVdrPoolService = agentContext.dependencyManager.resolve(pool_1.IndyVdrPoolService);
                        _a = (0, anoncreds_1.parseIndySchemaId)(schemaId), did = _a.did, namespaceIdentifier = _a.namespaceIdentifier, schemaName = _a.schemaName, schemaVersion = _a.schemaVersion;
                        return [4 /*yield*/, indyVdrPoolService.getPoolForDid(agentContext, did)];
                    case 1:
                        pool = (_b.sent()).pool;
                        agentContext.config.logger.debug("Getting schema '".concat(schemaId, "' from ledger '").concat(pool.indyNamespace, "'"));
                        legacySchemaId = (0, anoncreds_1.getUnqualifiedSchemaId)(namespaceIdentifier, schemaName, schemaVersion);
                        request = new indy_vdr_shared_1.GetSchemaRequest({ schemaId: legacySchemaId });
                        agentContext.config.logger.trace("Submitting get schema request for schema '".concat(schemaId, "' to ledger '").concat(pool.indyNamespace, "'"));
                        return [4 /*yield*/, pool.submitRequest(request)];
                    case 2:
                        response = _b.sent();
                        agentContext.config.logger.trace("Got un-parsed schema '".concat(schemaId, "' from ledger '").concat(pool.indyNamespace, "'"), {
                            response: response,
                        });
                        if (!('attr_names' in response.result.data)) {
                            agentContext.config.logger.error("Error retrieving schema '".concat(schemaId, "'"));
                            return [2 /*return*/, {
                                    schemaId: schemaId,
                                    resolutionMetadata: {
                                        error: 'notFound',
                                        message: "unable to find schema with id ".concat(schemaId),
                                    },
                                    schemaMetadata: {},
                                }];
                        }
                        return [2 /*return*/, {
                                schema: {
                                    attrNames: response.result.data.attr_names,
                                    name: response.result.data.name,
                                    version: response.result.data.version,
                                    issuerId: did,
                                },
                                schemaId: schemaId,
                                resolutionMetadata: {},
                                schemaMetadata: {
                                    didIndyNamespace: pool.indyNamespace,
                                    // NOTE: the seqNo is required by the indy-sdk even though not present in AnonCreds v1.
                                    // For this reason we return it in the metadata.
                                    indyLedgerSeqNo: response.result.seqNo,
                                },
                            }];
                    case 3:
                        error_1 = _b.sent();
                        agentContext.config.logger.error("Error retrieving schema '".concat(schemaId, "'"), {
                            error: error_1,
                            schemaId: schemaId,
                        });
                        return [2 /*return*/, {
                                schemaId: schemaId,
                                resolutionMetadata: {
                                    error: 'notFound',
                                },
                                schemaMetadata: {},
                            }];
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    IndyVdrAnonCredsRegistry.prototype.registerSchema = function (agentContext, options) {
        return __awaiter(this, void 0, void 0, function () {
            var schema, issuerId, name, version, attrNames, _a, namespaceIdentifier, namespace, _b, endorserDid, endorserMode, indyVdrPoolService, pool, writeRequest, didIndySchemaId, endorsedTransaction, legacySchemaId, schemaRequest, submitterKey, endorserKey, response, error_2;
            var _c, _d;
            return __generator(this, function (_e) {
                switch (_e.label) {
                    case 0:
                        schema = options.schema;
                        issuerId = schema.issuerId, name = schema.name, version = schema.version, attrNames = schema.attrNames;
                        _e.label = 1;
                    case 1:
                        _e.trys.push([1, 9, , 10]);
                        _a = (0, anoncreds_1.parseIndyDid)(issuerId), namespaceIdentifier = _a.namespaceIdentifier, namespace = _a.namespace;
                        _b = options.options, endorserDid = _b.endorserDid, endorserMode = _b.endorserMode;
                        indyVdrPoolService = agentContext.dependencyManager.resolve(pool_1.IndyVdrPoolService);
                        pool = indyVdrPoolService.getPoolForNamespace(namespace);
                        writeRequest = void 0;
                        didIndySchemaId = (0, identifiers_1.getDidIndySchemaId)(namespace, namespaceIdentifier, schema.name, schema.version);
                        endorsedTransaction = options.options.endorsedTransaction;
                        if (!endorsedTransaction) return [3 /*break*/, 2];
                        agentContext.config.logger.debug("Preparing endorsed tx '".concat(endorsedTransaction, "' for submission on ledger '").concat(namespace, "' with did '").concat(issuerId, "'"), schema);
                        writeRequest = new indy_vdr_shared_1.CustomRequest({ customRequest: endorsedTransaction });
                        return [3 /*break*/, 7];
                    case 2:
                        agentContext.config.logger.debug("Create schema tx on ledger '".concat(namespace, "' with did '").concat(issuerId, "'"), schema);
                        legacySchemaId = (0, anoncreds_1.getUnqualifiedSchemaId)(namespaceIdentifier, name, version);
                        schemaRequest = new indy_vdr_shared_1.SchemaRequest({
                            submitterDid: namespaceIdentifier,
                            schema: { id: legacySchemaId, name: name, ver: '1.0', version: version, attrNames: attrNames },
                        });
                        return [4 /*yield*/, (0, didIndyUtil_1.verificationKeyForIndyDid)(agentContext, issuerId)];
                    case 3:
                        submitterKey = _e.sent();
                        return [4 /*yield*/, pool.prepareWriteRequest(agentContext, schemaRequest, submitterKey, endorserDid !== issuerId ? endorserDid : undefined)];
                    case 4:
                        writeRequest = _e.sent();
                        if (endorserMode === 'external') {
                            return [2 /*return*/, {
                                    jobId: didIndySchemaId,
                                    schemaState: {
                                        state: 'action',
                                        action: 'endorseIndyTransaction',
                                        schemaId: didIndySchemaId,
                                        schema: schema,
                                        schemaRequest: writeRequest.body,
                                    },
                                    registrationMetadata: {},
                                    schemaMetadata: {},
                                }];
                        }
                        if (!(endorserMode === 'internal' && endorserDid !== issuerId)) return [3 /*break*/, 7];
                        return [4 /*yield*/, (0, didIndyUtil_1.verificationKeyForIndyDid)(agentContext, endorserDid)];
                    case 5:
                        endorserKey = _e.sent();
                        return [4 /*yield*/, (0, sign_1.multiSignRequest)(agentContext, writeRequest, endorserKey, (0, anoncreds_1.parseIndyDid)(endorserDid).namespaceIdentifier)];
                    case 6:
                        _e.sent();
                        _e.label = 7;
                    case 7: return [4 /*yield*/, pool.submitRequest(writeRequest)];
                    case 8:
                        response = _e.sent();
                        agentContext.config.logger.debug("Registered schema '".concat(didIndySchemaId, "' on ledger '").concat(pool.indyNamespace, "'"), {
                            response: response,
                            writeRequest: writeRequest,
                        });
                        return [2 /*return*/, {
                                schemaState: {
                                    state: 'finished',
                                    schema: schema,
                                    schemaId: didIndySchemaId,
                                },
                                registrationMetadata: {},
                                schemaMetadata: {
                                    // NOTE: the seqNo is required by the indy-sdk even though not present in AnonCreds v1.
                                    // For this reason we return it in the metadata.
                                    // Cast to SchemaResponse to pass type check
                                    indyLedgerSeqNo: (_d = (_c = response === null || response === void 0 ? void 0 : response.result) === null || _c === void 0 ? void 0 : _c.txnMetadata) === null || _d === void 0 ? void 0 : _d.seqNo,
                                },
                            }];
                    case 9:
                        error_2 = _e.sent();
                        agentContext.config.logger.error("Error registering schema for did '".concat(issuerId, "'"), {
                            error: error_2,
                            did: issuerId,
                            schema: schema,
                        });
                        return [2 /*return*/, {
                                schemaMetadata: {},
                                registrationMetadata: {},
                                schemaState: {
                                    state: 'failed',
                                    schema: schema,
                                    reason: "unknownError: ".concat(error_2.message),
                                },
                            }];
                    case 10: return [2 /*return*/];
                }
            });
        });
    };
    IndyVdrAnonCredsRegistry.prototype.getCredentialDefinition = function (agentContext, credentialDefinitionId) {
        return __awaiter(this, void 0, void 0, function () {
            var indyVdrPoolService, _a, did, namespaceIdentifier, schemaSeqNo, tag, pool, legacyCredentialDefinitionId, request, response, schema, schemaId, error_3;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _b.trys.push([0, 4, , 5]);
                        indyVdrPoolService = agentContext.dependencyManager.resolve(pool_1.IndyVdrPoolService);
                        _a = (0, anoncreds_1.parseIndyCredentialDefinitionId)(credentialDefinitionId), did = _a.did, namespaceIdentifier = _a.namespaceIdentifier, schemaSeqNo = _a.schemaSeqNo, tag = _a.tag;
                        return [4 /*yield*/, indyVdrPoolService.getPoolForDid(agentContext, did)];
                    case 1:
                        pool = (_b.sent()).pool;
                        agentContext.config.logger.debug("Getting credential definition '".concat(credentialDefinitionId, "' from ledger '").concat(pool.indyNamespace, "'"));
                        legacyCredentialDefinitionId = (0, anoncreds_1.getUnqualifiedCredentialDefinitionId)(namespaceIdentifier, schemaSeqNo, tag);
                        request = new indy_vdr_shared_1.GetCredentialDefinitionRequest({
                            credentialDefinitionId: legacyCredentialDefinitionId,
                        });
                        agentContext.config.logger.trace("Submitting get credential definition request for credential definition '".concat(credentialDefinitionId, "' to ledger '").concat(pool.indyNamespace, "'"));
                        return [4 /*yield*/, pool.submitRequest(request)
                            // We need to fetch the schema to determine the schemaId (we only have the seqNo)
                        ];
                    case 2:
                        response = _b.sent();
                        return [4 /*yield*/, this.fetchIndySchemaWithSeqNo(agentContext, response.result.ref, namespaceIdentifier)];
                    case 3:
                        schema = _b.sent();
                        if (!schema || !response.result.data) {
                            agentContext.config.logger.error("Error retrieving credential definition '".concat(credentialDefinitionId, "'"));
                            return [2 /*return*/, {
                                    credentialDefinitionId: credentialDefinitionId,
                                    credentialDefinitionMetadata: {},
                                    resolutionMetadata: {
                                        error: 'notFound',
                                        message: "unable to resolve credential definition with id ".concat(credentialDefinitionId),
                                    },
                                }];
                        }
                        schemaId = credentialDefinitionId.startsWith('did:indy')
                            ? (0, identifiers_1.getDidIndySchemaId)(pool.indyNamespace, schema.schema.issuerId, schema.schema.name, schema.schema.version)
                            : schema.schema.schemaId;
                        return [2 /*return*/, {
                                credentialDefinitionId: credentialDefinitionId,
                                credentialDefinition: {
                                    issuerId: did,
                                    schemaId: schemaId,
                                    tag: response.result.tag,
                                    type: 'CL',
                                    value: response.result.data,
                                },
                                credentialDefinitionMetadata: {
                                    didIndyNamespace: pool.indyNamespace,
                                },
                                resolutionMetadata: {},
                            }];
                    case 4:
                        error_3 = _b.sent();
                        agentContext.config.logger.error("Error retrieving credential definition '".concat(credentialDefinitionId, "'"), {
                            error: error_3,
                            credentialDefinitionId: credentialDefinitionId,
                        });
                        return [2 /*return*/, {
                                credentialDefinitionId: credentialDefinitionId,
                                credentialDefinitionMetadata: {},
                                resolutionMetadata: {
                                    error: 'notFound',
                                    message: "unable to resolve credential definition: ".concat(error_3.message),
                                },
                            }];
                    case 5: return [2 /*return*/];
                }
            });
        });
    };
    IndyVdrAnonCredsRegistry.prototype.registerCredentialDefinition = function (agentContext, options) {
        return __awaiter(this, void 0, void 0, function () {
            var credentialDefinition, schemaId, issuerId, tag, value, _a, namespaceIdentifier, namespace, _b, endorserDid, endorserMode, indyVdrPoolService, pool, writeRequest, didIndyCredentialDefinitionId, schemaSeqNo, endorsedTransaction, operation, _c, schemaMetadata, resolutionMetadata, legacyCredentialDefinitionId, credentialDefinitionRequest, submitterKey, endorserKey, response, error_4;
            var _d;
            return __generator(this, function (_e) {
                switch (_e.label) {
                    case 0:
                        credentialDefinition = options.credentialDefinition;
                        schemaId = credentialDefinition.schemaId, issuerId = credentialDefinition.issuerId, tag = credentialDefinition.tag, value = credentialDefinition.value;
                        _e.label = 1;
                    case 1:
                        _e.trys.push([1, 10, , 11]);
                        _a = (0, anoncreds_1.parseIndyDid)(issuerId), namespaceIdentifier = _a.namespaceIdentifier, namespace = _a.namespace;
                        _b = options.options, endorserDid = _b.endorserDid, endorserMode = _b.endorserMode;
                        indyVdrPoolService = agentContext.dependencyManager.resolve(pool_1.IndyVdrPoolService);
                        pool = indyVdrPoolService.getPoolForNamespace(namespace);
                        agentContext.config.logger.debug("Registering credential definition on ledger '".concat(namespace, "' with did '").concat(issuerId, "'"), options.credentialDefinition);
                        writeRequest = void 0;
                        didIndyCredentialDefinitionId = void 0;
                        schemaSeqNo = void 0;
                        endorsedTransaction = options.options.endorsedTransaction;
                        if (!endorsedTransaction) return [3 /*break*/, 2];
                        agentContext.config.logger.debug("Preparing endorsed tx '".concat(endorsedTransaction, "' for submission on ledger '").concat(namespace, "' with did '").concat(issuerId, "'"), credentialDefinition);
                        writeRequest = new indy_vdr_shared_1.CustomRequest({ customRequest: endorsedTransaction });
                        operation = (_d = JSON.parse(endorsedTransaction)) === null || _d === void 0 ? void 0 : _d.operation;
                        // extract the seqNo from the endorsed transaction, which is contained in the ref field of the operation
                        schemaSeqNo = Number(operation === null || operation === void 0 ? void 0 : operation.ref);
                        didIndyCredentialDefinitionId = (0, identifiers_1.getDidIndyCredentialDefinitionId)(namespace, namespaceIdentifier, schemaSeqNo, tag);
                        return [3 /*break*/, 8];
                    case 2: return [4 /*yield*/, this.getSchema(agentContext, schemaId)];
                    case 3:
                        _c = _e.sent(), schemaMetadata = _c.schemaMetadata, resolutionMetadata = _c.resolutionMetadata;
                        if (!(schemaMetadata === null || schemaMetadata === void 0 ? void 0 : schemaMetadata.indyLedgerSeqNo) || typeof schemaMetadata.indyLedgerSeqNo !== 'number') {
                            return [2 /*return*/, {
                                    registrationMetadata: {},
                                    credentialDefinitionMetadata: {
                                        didIndyNamespace: pool.indyNamespace,
                                    },
                                    credentialDefinitionState: {
                                        credentialDefinition: options.credentialDefinition,
                                        state: 'failed',
                                        reason: "error resolving schema with id ".concat(schemaId, ": ").concat(resolutionMetadata.error, " ").concat(resolutionMetadata.message),
                                    },
                                }];
                        }
                        schemaSeqNo = schemaMetadata.indyLedgerSeqNo;
                        legacyCredentialDefinitionId = (0, anoncreds_1.getUnqualifiedCredentialDefinitionId)(issuerId, schemaSeqNo, tag);
                        didIndyCredentialDefinitionId = (0, identifiers_1.getDidIndyCredentialDefinitionId)(namespace, namespaceIdentifier, schemaSeqNo, tag);
                        credentialDefinitionRequest = new indy_vdr_shared_1.CredentialDefinitionRequest({
                            submitterDid: namespaceIdentifier,
                            credentialDefinition: {
                                ver: '1.0',
                                id: legacyCredentialDefinitionId,
                                schemaId: schemaSeqNo.toString(),
                                type: 'CL',
                                tag: tag,
                                value: value,
                            },
                        });
                        return [4 /*yield*/, (0, didIndyUtil_1.verificationKeyForIndyDid)(agentContext, issuerId)];
                    case 4:
                        submitterKey = _e.sent();
                        return [4 /*yield*/, pool.prepareWriteRequest(agentContext, credentialDefinitionRequest, submitterKey, endorserDid !== issuerId ? endorserDid : undefined)];
                    case 5:
                        writeRequest = _e.sent();
                        if (endorserMode === 'external') {
                            return [2 /*return*/, {
                                    jobId: didIndyCredentialDefinitionId,
                                    credentialDefinitionState: {
                                        state: 'action',
                                        action: 'endorseIndyTransaction',
                                        credentialDefinition: credentialDefinition,
                                        credentialDefinitionId: didIndyCredentialDefinitionId,
                                        credentialDefinitionRequest: writeRequest.body,
                                    },
                                    registrationMetadata: {},
                                    credentialDefinitionMetadata: {},
                                }];
                        }
                        if (!(endorserMode === 'internal' && endorserDid !== issuerId)) return [3 /*break*/, 8];
                        return [4 /*yield*/, (0, didIndyUtil_1.verificationKeyForIndyDid)(agentContext, endorserDid)];
                    case 6:
                        endorserKey = _e.sent();
                        return [4 /*yield*/, (0, sign_1.multiSignRequest)(agentContext, writeRequest, endorserKey, (0, anoncreds_1.parseIndyDid)(endorserDid).namespaceIdentifier)];
                    case 7:
                        _e.sent();
                        _e.label = 8;
                    case 8: return [4 /*yield*/, pool.submitRequest(writeRequest)];
                    case 9:
                        response = _e.sent();
                        agentContext.config.logger.debug("Registered credential definition '".concat(didIndyCredentialDefinitionId, "' on ledger '").concat(pool.indyNamespace, "'"), {
                            response: response,
                            credentialDefinition: options.credentialDefinition,
                        });
                        return [2 /*return*/, {
                                credentialDefinitionMetadata: {},
                                credentialDefinitionState: {
                                    credentialDefinition: credentialDefinition,
                                    credentialDefinitionId: didIndyCredentialDefinitionId,
                                    state: 'finished',
                                },
                                registrationMetadata: {},
                            }];
                    case 10:
                        error_4 = _e.sent();
                        agentContext.config.logger.error("Error registering credential definition for schema '".concat(schemaId, "'"), {
                            error: error_4,
                            did: issuerId,
                            credentialDefinition: options.credentialDefinition,
                        });
                        return [2 /*return*/, {
                                credentialDefinitionMetadata: {},
                                registrationMetadata: {},
                                credentialDefinitionState: {
                                    credentialDefinition: options.credentialDefinition,
                                    state: 'failed',
                                    reason: "unknownError: ".concat(error_4.message),
                                },
                            }];
                    case 11: return [2 /*return*/];
                }
            });
        });
    };
    IndyVdrAnonCredsRegistry.prototype.getRevocationRegistryDefinition = function (agentContext, revocationRegistryDefinitionId) {
        return __awaiter(this, void 0, void 0, function () {
            var indyVdrPoolService, _a, did, namespaceIdentifier, credentialDefinitionTag, revocationRegistryTag, schemaSeqNo, pool, legacyRevocationRegistryId, request, response, credentialDefinitionId, revocationRegistryDefinition, error_5;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _b.trys.push([0, 3, , 4]);
                        indyVdrPoolService = agentContext.dependencyManager.resolve(pool_1.IndyVdrPoolService);
                        _a = (0, anoncreds_1.parseIndyRevocationRegistryId)(revocationRegistryDefinitionId), did = _a.did, namespaceIdentifier = _a.namespaceIdentifier, credentialDefinitionTag = _a.credentialDefinitionTag, revocationRegistryTag = _a.revocationRegistryTag, schemaSeqNo = _a.schemaSeqNo;
                        return [4 /*yield*/, indyVdrPoolService.getPoolForDid(agentContext, did)];
                    case 1:
                        pool = (_b.sent()).pool;
                        agentContext.config.logger.debug("Using ledger '".concat(pool.indyNamespace, "' to retrieve revocation registry definition '").concat(revocationRegistryDefinitionId, "'"));
                        legacyRevocationRegistryId = (0, anoncreds_1.getUnqualifiedRevocationRegistryDefinitionId)(namespaceIdentifier, schemaSeqNo, credentialDefinitionTag, revocationRegistryTag);
                        request = new indy_vdr_shared_1.GetRevocationRegistryDefinitionRequest({
                            revocationRegistryId: legacyRevocationRegistryId,
                        });
                        agentContext.config.logger.trace("Submitting get revocation registry definition request for revocation registry definition '".concat(revocationRegistryDefinitionId, "' to ledger"));
                        return [4 /*yield*/, pool.submitRequest(request)];
                    case 2:
                        response = _b.sent();
                        if (!response.result.data) {
                            agentContext.config.logger.error("Error retrieving revocation registry definition '".concat(revocationRegistryDefinitionId, "' from ledger"), {
                                revocationRegistryDefinitionId: revocationRegistryDefinitionId,
                            });
                            return [2 /*return*/, {
                                    resolutionMetadata: {
                                        error: 'notFound',
                                        message: 'unable to resolve revocation registry definition',
                                    },
                                    revocationRegistryDefinitionId: revocationRegistryDefinitionId,
                                    revocationRegistryDefinitionMetadata: {},
                                }];
                        }
                        agentContext.config.logger.trace("Got revocation registry definition '".concat(revocationRegistryDefinitionId, "' from ledger '").concat(pool.indyNamespace, "'"), {
                            response: response,
                        });
                        credentialDefinitionId = revocationRegistryDefinitionId.startsWith('did:indy:')
                            ? (0, identifiers_1.getDidIndyCredentialDefinitionId)(pool.indyNamespace, namespaceIdentifier, schemaSeqNo, credentialDefinitionTag)
                            : (0, anoncreds_1.getUnqualifiedCredentialDefinitionId)(namespaceIdentifier, schemaSeqNo, credentialDefinitionTag);
                        revocationRegistryDefinition = {
                            issuerId: did,
                            revocDefType: response.result.data.revocDefType,
                            value: {
                                maxCredNum: response.result.data.value.maxCredNum,
                                tailsHash: response.result.data.value.tailsHash,
                                tailsLocation: response.result.data.value.tailsLocation,
                                publicKeys: {
                                    accumKey: {
                                        z: response.result.data.value.publicKeys.accumKey.z,
                                    },
                                },
                            },
                            tag: response.result.data.tag,
                            credDefId: credentialDefinitionId,
                        };
                        return [2 /*return*/, {
                                revocationRegistryDefinitionId: revocationRegistryDefinitionId,
                                revocationRegistryDefinition: revocationRegistryDefinition,
                                revocationRegistryDefinitionMetadata: {
                                    issuanceType: response.result.data.value.issuanceType,
                                    didIndyNamespace: pool.indyNamespace,
                                },
                                resolutionMetadata: {},
                            }];
                    case 3:
                        error_5 = _b.sent();
                        agentContext.config.logger.error("Error retrieving revocation registry definition '".concat(revocationRegistryDefinitionId, "' from ledger"), {
                            error: error_5,
                            revocationRegistryDefinitionId: revocationRegistryDefinitionId,
                        });
                        return [2 /*return*/, {
                                resolutionMetadata: {
                                    error: 'notFound',
                                    message: "unable to resolve revocation registry definition: ".concat(error_5.message),
                                },
                                revocationRegistryDefinitionId: revocationRegistryDefinitionId,
                                revocationRegistryDefinitionMetadata: {},
                            }];
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    IndyVdrAnonCredsRegistry.prototype.registerRevocationRegistryDefinition = function (agentContext_1, _a) {
        return __awaiter(this, arguments, void 0, function (agentContext, _b) {
            var _c, namespaceIdentifier, namespace, indyVdrPoolService, pool, writeRequest, didIndyRevocationRegistryDefinitionId, _d, schemaSeqNo, credentialDefinitionTag, endorsedTransaction, endorserDid, endorserMode, legacyRevocationRegistryDefinitionId, legacyCredentialDefinitionId, revocationRegistryDefinitionRequest, submitterKey, endorserKey, response, error_6;
            var options = _b.options, revocationRegistryDefinition = _b.revocationRegistryDefinition;
            return __generator(this, function (_e) {
                switch (_e.label) {
                    case 0:
                        _e.trys.push([0, 8, , 9]);
                        _c = (0, anoncreds_1.parseIndyDid)(revocationRegistryDefinition.issuerId), namespaceIdentifier = _c.namespaceIdentifier, namespace = _c.namespace;
                        indyVdrPoolService = agentContext.dependencyManager.resolve(pool_1.IndyVdrPoolService);
                        pool = indyVdrPoolService.getPoolForNamespace(namespace);
                        agentContext.config.logger.debug("Registering revocation registry definition on ledger '".concat(namespace, "' with did '").concat(revocationRegistryDefinition.issuerId, "'"), revocationRegistryDefinition);
                        writeRequest = void 0;
                        didIndyRevocationRegistryDefinitionId = void 0;
                        _d = (0, anoncreds_1.parseIndyCredentialDefinitionId)(revocationRegistryDefinition.credDefId), schemaSeqNo = _d.schemaSeqNo, credentialDefinitionTag = _d.tag;
                        endorsedTransaction = options.endorsedTransaction, endorserDid = options.endorserDid, endorserMode = options.endorserMode;
                        if (!endorsedTransaction) return [3 /*break*/, 1];
                        agentContext.config.logger.debug("Preparing endorsed tx '".concat(endorsedTransaction, "' for submission on ledger '").concat(namespace, "' with did '").concat(revocationRegistryDefinition.issuerId, "'"), revocationRegistryDefinition);
                        writeRequest = new indy_vdr_shared_1.CustomRequest({ customRequest: endorsedTransaction });
                        didIndyRevocationRegistryDefinitionId = (0, identifiers_1.getDidIndyRevocationRegistryDefinitionId)(namespace, namespaceIdentifier, schemaSeqNo, credentialDefinitionTag, revocationRegistryDefinition.tag);
                        return [3 /*break*/, 6];
                    case 1:
                        legacyRevocationRegistryDefinitionId = (0, anoncreds_1.getUnqualifiedRevocationRegistryDefinitionId)(namespaceIdentifier, schemaSeqNo, credentialDefinitionTag, revocationRegistryDefinition.tag);
                        didIndyRevocationRegistryDefinitionId = (0, identifiers_1.getDidIndyRevocationRegistryDefinitionId)(namespace, namespaceIdentifier, schemaSeqNo, credentialDefinitionTag, revocationRegistryDefinition.tag);
                        legacyCredentialDefinitionId = (0, anoncreds_1.getUnqualifiedCredentialDefinitionId)(namespaceIdentifier, schemaSeqNo, credentialDefinitionTag);
                        revocationRegistryDefinitionRequest = new indy_vdr_shared_1.RevocationRegistryDefinitionRequest({
                            submitterDid: namespaceIdentifier,
                            revocationRegistryDefinitionV1: {
                                id: legacyRevocationRegistryDefinitionId,
                                ver: '1.0',
                                credDefId: legacyCredentialDefinitionId,
                                tag: revocationRegistryDefinition.tag,
                                revocDefType: revocationRegistryDefinition.revocDefType,
                                value: __assign({ issuanceType: 'ISSUANCE_BY_DEFAULT' }, revocationRegistryDefinition.value),
                            },
                        });
                        return [4 /*yield*/, (0, didIndyUtil_1.verificationKeyForIndyDid)(agentContext, revocationRegistryDefinition.issuerId)];
                    case 2:
                        submitterKey = _e.sent();
                        return [4 /*yield*/, pool.prepareWriteRequest(agentContext, revocationRegistryDefinitionRequest, submitterKey, endorserDid !== revocationRegistryDefinition.issuerId ? endorserDid : undefined)];
                    case 3:
                        writeRequest = _e.sent();
                        if (endorserMode === 'external') {
                            return [2 /*return*/, {
                                    jobId: didIndyRevocationRegistryDefinitionId,
                                    revocationRegistryDefinitionState: {
                                        state: 'action',
                                        action: 'endorseIndyTransaction',
                                        revocationRegistryDefinition: revocationRegistryDefinition,
                                        revocationRegistryDefinitionId: didIndyRevocationRegistryDefinitionId,
                                        revocationRegistryDefinitionRequest: writeRequest.body,
                                    },
                                    registrationMetadata: {},
                                    revocationRegistryDefinitionMetadata: {},
                                }];
                        }
                        if (!(endorserMode === 'internal' && endorserDid !== revocationRegistryDefinition.issuerId)) return [3 /*break*/, 6];
                        return [4 /*yield*/, (0, didIndyUtil_1.verificationKeyForIndyDid)(agentContext, endorserDid)];
                    case 4:
                        endorserKey = _e.sent();
                        return [4 /*yield*/, (0, sign_1.multiSignRequest)(agentContext, writeRequest, endorserKey, (0, anoncreds_1.parseIndyDid)(endorserDid).namespaceIdentifier)];
                    case 5:
                        _e.sent();
                        _e.label = 6;
                    case 6: return [4 /*yield*/, pool.submitRequest(writeRequest)];
                    case 7:
                        response = _e.sent();
                        agentContext.config.logger.debug("Registered revocation registry definition '".concat(didIndyRevocationRegistryDefinitionId, "' on ledger '").concat(pool.indyNamespace, "'"), {
                            response: response,
                            revocationRegistryDefinition: revocationRegistryDefinition,
                        });
                        return [2 /*return*/, {
                                revocationRegistryDefinitionMetadata: {},
                                revocationRegistryDefinitionState: {
                                    revocationRegistryDefinition: revocationRegistryDefinition,
                                    revocationRegistryDefinitionId: didIndyRevocationRegistryDefinitionId,
                                    state: 'finished',
                                },
                                registrationMetadata: {},
                            }];
                    case 8:
                        error_6 = _e.sent();
                        agentContext.config.logger.error("Error registering revocation registry definition for credential definition '".concat(revocationRegistryDefinition.credDefId, "'"), {
                            error: error_6,
                            did: revocationRegistryDefinition.issuerId,
                            revocationRegistryDefinition: revocationRegistryDefinition,
                        });
                        return [2 /*return*/, {
                                revocationRegistryDefinitionMetadata: {},
                                registrationMetadata: {},
                                revocationRegistryDefinitionState: {
                                    revocationRegistryDefinition: revocationRegistryDefinition,
                                    state: 'failed',
                                    reason: "unknownError: ".concat(error_6.message),
                                },
                            }];
                    case 9: return [2 /*return*/];
                }
            });
        });
    };
    IndyVdrAnonCredsRegistry.prototype.getRevocationStatusList = function (agentContext, revocationRegistryDefinitionId, timestamp) {
        return __awaiter(this, void 0, void 0, function () {
            var indyVdrPoolService, did, pool, revocationDelta, _a, revocationRegistryDefinition, resolutionMetadata, revocationRegistryDefinitionMetadata, isIssuanceByDefault, error_7;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _b.trys.push([0, 4, , 5]);
                        indyVdrPoolService = agentContext.dependencyManager.resolve(pool_1.IndyVdrPoolService);
                        did = (0, anoncreds_1.parseIndyRevocationRegistryId)(revocationRegistryDefinitionId).did;
                        return [4 /*yield*/, indyVdrPoolService.getPoolForDid(agentContext, did)];
                    case 1:
                        pool = (_b.sent()).pool;
                        return [4 /*yield*/, this.fetchIndyRevocationDelta(agentContext, revocationRegistryDefinitionId, timestamp)];
                    case 2:
                        revocationDelta = _b.sent();
                        if (!revocationDelta) {
                            return [2 /*return*/, {
                                    resolutionMetadata: {
                                        error: 'notFound',
                                        message: "Error retrieving revocation registry delta '".concat(revocationRegistryDefinitionId, "' from ledger, potentially revocation interval ends before revocation registry creation"),
                                    },
                                    revocationStatusListMetadata: {},
                                }];
                        }
                        return [4 /*yield*/, this.getRevocationRegistryDefinition(agentContext, revocationRegistryDefinitionId)];
                    case 3:
                        _a = _b.sent(), revocationRegistryDefinition = _a.revocationRegistryDefinition, resolutionMetadata = _a.resolutionMetadata, revocationRegistryDefinitionMetadata = _a.revocationRegistryDefinitionMetadata;
                        if (!revocationRegistryDefinition ||
                            !revocationRegistryDefinitionMetadata.issuanceType ||
                            typeof revocationRegistryDefinitionMetadata.issuanceType !== 'string') {
                            return [2 /*return*/, {
                                    resolutionMetadata: {
                                        error: "error resolving revocation registry definition with id ".concat(revocationRegistryDefinitionId, ": ").concat(resolutionMetadata.error, " ").concat(resolutionMetadata.message),
                                    },
                                    revocationStatusListMetadata: {
                                        didIndyNamespace: pool.indyNamespace,
                                    },
                                }];
                        }
                        isIssuanceByDefault = revocationRegistryDefinitionMetadata.issuanceType === 'ISSUANCE_BY_DEFAULT';
                        return [2 /*return*/, {
                                resolutionMetadata: {},
                                revocationStatusList: (0, transform_1.anonCredsRevocationStatusListFromIndyVdr)(revocationRegistryDefinitionId, revocationRegistryDefinition, revocationDelta, isIssuanceByDefault),
                                revocationStatusListMetadata: {
                                    didIndyNamespace: pool.indyNamespace,
                                },
                            }];
                    case 4:
                        error_7 = _b.sent();
                        agentContext.config.logger.error("Error retrieving revocation registry delta '".concat(revocationRegistryDefinitionId, "' from ledger, potentially revocation interval ends before revocation registry creation?\""), {
                            error: error_7,
                            revocationRegistryId: revocationRegistryDefinitionId,
                        });
                        return [2 /*return*/, {
                                resolutionMetadata: {
                                    error: 'notFound',
                                    message: "Error retrieving revocation registry delta '".concat(revocationRegistryDefinitionId, "' from ledger, potentially revocation interval ends before revocation registry creation: ").concat(error_7.message),
                                },
                                revocationStatusListMetadata: {},
                            }];
                    case 5: return [2 /*return*/];
                }
            });
        });
    };
    IndyVdrAnonCredsRegistry.prototype.registerRevocationStatusList = function (agentContext_1, _a) {
        return __awaiter(this, arguments, void 0, function (agentContext, _b) {
            var endorsedTransaction, endorserDid, endorserMode, _c, namespaceIdentifier, namespace, indyVdrPoolService, pool, writeRequest, _d, schemaSeqNo, credentialDefinitionTag, revocationRegistryNamespaceIdentifier, revocationRegistryTag, revocationRegistryNamespace, legacyRevocationRegistryDefinitionId, didIndyRevocationRegistryEntryId, previousDelta, revocationRegistryDefinitionEntryValue, revocationRegistryDefinitionRequest, submitterKey, endorserKey, response, error_8;
            var options = _b.options, revocationStatusList = _b.revocationStatusList;
            return __generator(this, function (_e) {
                switch (_e.label) {
                    case 0:
                        _e.trys.push([0, 9, , 10]);
                        endorsedTransaction = options.endorsedTransaction, endorserDid = options.endorserDid, endorserMode = options.endorserMode;
                        _c = (0, anoncreds_1.parseIndyDid)(revocationStatusList.issuerId), namespaceIdentifier = _c.namespaceIdentifier, namespace = _c.namespace;
                        indyVdrPoolService = agentContext.dependencyManager.resolve(pool_1.IndyVdrPoolService);
                        pool = indyVdrPoolService.getPoolForNamespace(namespace);
                        agentContext.config.logger.debug("Registering revocation status list on ledger '".concat(namespace, "' with did '").concat(revocationStatusList.issuerId, "'"), revocationStatusList);
                        writeRequest = void 0;
                        _d = (0, anoncreds_1.parseIndyRevocationRegistryId)(revocationStatusList.revRegDefId), schemaSeqNo = _d.schemaSeqNo, credentialDefinitionTag = _d.credentialDefinitionTag, revocationRegistryNamespaceIdentifier = _d.namespaceIdentifier, revocationRegistryTag = _d.revocationRegistryTag, revocationRegistryNamespace = _d.namespace;
                        legacyRevocationRegistryDefinitionId = (0, anoncreds_1.getUnqualifiedRevocationRegistryDefinitionId)(namespaceIdentifier, schemaSeqNo, credentialDefinitionTag, revocationRegistryTag);
                        didIndyRevocationRegistryEntryId = (0, identifiers_1.getDidIndyRevocationRegistryEntryId)(namespace, namespaceIdentifier, schemaSeqNo, credentialDefinitionTag, revocationRegistryTag);
                        if (revocationRegistryNamespace && revocationRegistryNamespace !== namespace) {
                            throw new core_1.CredoError("Issued id '".concat(revocationStatusList.issuerId, "' does not have the same namespace (").concat(namespace, ") as the revocation registry definition '").concat(revocationRegistryNamespace, "'"));
                        }
                        if (revocationRegistryNamespaceIdentifier !== namespaceIdentifier) {
                            throw new core_1.CredoError("Cannot register revocation registry definition using a different DID. Revocation registry definition contains '".concat(revocationRegistryNamespaceIdentifier, "', but DID used was '").concat(namespaceIdentifier, "'"));
                        }
                        if (!endorsedTransaction) return [3 /*break*/, 1];
                        agentContext.config.logger.debug("Preparing endorsed tx '".concat(endorsedTransaction, "' for submission on ledger '").concat(namespace, "' with did '").concat(revocationStatusList.issuerId, "'"), revocationStatusList);
                        writeRequest = new indy_vdr_shared_1.CustomRequest({ customRequest: endorsedTransaction });
                        return [3 /*break*/, 7];
                    case 1: return [4 /*yield*/, this.fetchIndyRevocationDelta(agentContext, legacyRevocationRegistryDefinitionId, 
                        // Fetch revocation delta for current timestamp
                        (0, anoncreds_1.dateToTimestamp)(new Date()))];
                    case 2:
                        previousDelta = _e.sent();
                        revocationRegistryDefinitionEntryValue = (0, transform_1.indyVdrCreateLatestRevocationDelta)(revocationStatusList.currentAccumulator, revocationStatusList.revocationList, previousDelta !== null && previousDelta !== void 0 ? previousDelta : undefined);
                        revocationRegistryDefinitionRequest = new indy_vdr_shared_1.RevocationRegistryEntryRequest({
                            submitterDid: namespaceIdentifier,
                            revocationRegistryEntry: {
                                ver: '1.0',
                                value: revocationRegistryDefinitionEntryValue,
                            },
                            revocationRegistryDefinitionType: 'CL_ACCUM',
                            revocationRegistryDefinitionId: legacyRevocationRegistryDefinitionId,
                        });
                        return [4 /*yield*/, (0, didIndyUtil_1.verificationKeyForIndyDid)(agentContext, revocationStatusList.issuerId)];
                    case 3:
                        submitterKey = _e.sent();
                        return [4 /*yield*/, pool.prepareWriteRequest(agentContext, revocationRegistryDefinitionRequest, submitterKey, endorserDid !== revocationStatusList.issuerId ? endorserDid : undefined)];
                    case 4:
                        writeRequest = _e.sent();
                        if (endorserMode === 'external') {
                            return [2 /*return*/, {
                                    jobId: didIndyRevocationRegistryEntryId,
                                    revocationStatusListState: {
                                        state: 'action',
                                        action: 'endorseIndyTransaction',
                                        revocationStatusList: revocationStatusList,
                                        revocationStatusListRequest: writeRequest.body,
                                    },
                                    registrationMetadata: {},
                                    revocationStatusListMetadata: {},
                                }];
                        }
                        if (!(endorserMode === 'internal' && endorserDid !== revocationStatusList.issuerId)) return [3 /*break*/, 7];
                        return [4 /*yield*/, (0, didIndyUtil_1.verificationKeyForIndyDid)(agentContext, endorserDid)];
                    case 5:
                        endorserKey = _e.sent();
                        return [4 /*yield*/, (0, sign_1.multiSignRequest)(agentContext, writeRequest, endorserKey, (0, anoncreds_1.parseIndyDid)(endorserDid).namespaceIdentifier)];
                    case 6:
                        _e.sent();
                        _e.label = 7;
                    case 7: return [4 /*yield*/, pool.submitRequest(writeRequest)];
                    case 8:
                        response = _e.sent();
                        agentContext.config.logger.debug("Registered revocation status list '".concat(didIndyRevocationRegistryEntryId, "' on ledger '").concat(pool.indyNamespace, "'"), {
                            response: response,
                            revocationStatusList: revocationStatusList,
                        });
                        return [2 /*return*/, {
                                revocationStatusListMetadata: {},
                                revocationStatusListState: {
                                    revocationStatusList: __assign(__assign({}, revocationStatusList), { timestamp: response.result.txnMetadata.txnTime }),
                                    state: 'finished',
                                },
                                registrationMetadata: {},
                            }];
                    case 9:
                        error_8 = _e.sent();
                        agentContext.config.logger.error("Error registering revocation status list for revocation registry definition '".concat(revocationStatusList.revRegDefId, "}'"), {
                            error: error_8,
                            did: revocationStatusList.issuerId,
                        });
                        return [2 /*return*/, {
                                registrationMetadata: {},
                                revocationStatusListMetadata: {},
                                revocationStatusListState: {
                                    revocationStatusList: revocationStatusList,
                                    state: 'failed',
                                    reason: "unknownError: ".concat(error_8.message),
                                },
                            }];
                    case 10: return [2 /*return*/];
                }
            });
        });
    };
    IndyVdrAnonCredsRegistry.prototype.fetchIndySchemaWithSeqNo = function (agentContext, seqNo, did) {
        return __awaiter(this, void 0, void 0, function () {
            var indyVdrPoolService, pool, request, response, schema, schemaDid, schemaId;
            var _a, _b, _c;
            return __generator(this, function (_d) {
                switch (_d.label) {
                    case 0:
                        indyVdrPoolService = agentContext.dependencyManager.resolve(pool_1.IndyVdrPoolService);
                        return [4 /*yield*/, indyVdrPoolService.getPoolForDid(agentContext, did)];
                    case 1:
                        pool = (_d.sent()).pool;
                        agentContext.config.logger.debug("Getting transaction with seqNo '".concat(seqNo, "' from ledger '").concat(pool.indyNamespace, "'"));
                        request = new indy_vdr_shared_1.GetTransactionRequest({ ledgerType: 1, seqNo: seqNo });
                        agentContext.config.logger.trace("Submitting get transaction request to ledger '".concat(pool.indyNamespace, "'"));
                        return [4 /*yield*/, pool.submitRequest(request)];
                    case 2:
                        response = _d.sent();
                        if (((_a = response.result.data) === null || _a === void 0 ? void 0 : _a.txn.type) !== '101') {
                            agentContext.config.logger.error("Could not get schema from ledger for seq no ".concat(seqNo, "'"));
                            return [2 /*return*/, null];
                        }
                        schema = (_b = response.result.data) === null || _b === void 0 ? void 0 : _b.txn.data;
                        schemaDid = (_c = response.result.data) === null || _c === void 0 ? void 0 : _c.txn.metadata.from;
                        schemaId = (0, anoncreds_1.getUnqualifiedSchemaId)(schemaDid, schema.data.name, schema.data.version);
                        return [2 /*return*/, {
                                schema: {
                                    schemaId: schemaId,
                                    attr_name: schema.data.attr_names,
                                    name: schema.data.name,
                                    version: schema.data.version,
                                    issuerId: schemaDid,
                                    seqNo: seqNo,
                                },
                                indyNamespace: pool.indyNamespace,
                            }];
                }
            });
        });
    };
    IndyVdrAnonCredsRegistry.prototype.fetchIndyRevocationDelta = function (agentContext, revocationRegistryDefinitionId, toTs) {
        return __awaiter(this, void 0, void 0, function () {
            var indyVdrPoolService, _a, did, namespaceIdentifier, schemaSeqNo, credentialDefinitionTag, revocationRegistryTag, pool, legacyRevocationRegistryDefinitionId, deltaRequest, response, _b, data, type, txnTime;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        indyVdrPoolService = agentContext.dependencyManager.resolve(pool_1.IndyVdrPoolService);
                        _a = (0, anoncreds_1.parseIndyRevocationRegistryId)(revocationRegistryDefinitionId), did = _a.did, namespaceIdentifier = _a.namespaceIdentifier, schemaSeqNo = _a.schemaSeqNo, credentialDefinitionTag = _a.credentialDefinitionTag, revocationRegistryTag = _a.revocationRegistryTag;
                        return [4 /*yield*/, indyVdrPoolService.getPoolForDid(agentContext, did)];
                    case 1:
                        pool = (_c.sent()).pool;
                        agentContext.config.logger.debug("Using ledger '".concat(pool.indyNamespace, "' to retrieve revocation registry deltas with revocation registry definition id '").concat(revocationRegistryDefinitionId, "' until ").concat(toTs));
                        legacyRevocationRegistryDefinitionId = (0, anoncreds_1.getUnqualifiedRevocationRegistryDefinitionId)(namespaceIdentifier, schemaSeqNo, credentialDefinitionTag, revocationRegistryTag);
                        deltaRequest = new indy_vdr_shared_1.GetRevocationRegistryDeltaRequest({
                            toTs: toTs,
                            submitterDid: namespaceIdentifier,
                            revocationRegistryId: legacyRevocationRegistryDefinitionId,
                        });
                        agentContext.config.logger.trace("Submitting get transaction request to ledger '".concat(pool.indyNamespace, "'"));
                        return [4 /*yield*/, pool.submitRequest(deltaRequest)];
                    case 2:
                        response = _c.sent();
                        _b = response.result, data = _b.data, type = _b.type, txnTime = _b.txnTime;
                        // Indicating there are no deltas
                        if (type !== '117' || data === null || !txnTime) {
                            agentContext.config.logger.warn("Could not get any deltas from ledger for revocation registry definition '".concat(revocationRegistryDefinitionId, "' from ledger '").concat(pool.indyNamespace, "'"));
                            return [2 /*return*/, null];
                        }
                        return [2 /*return*/, {
                                revoked: data.value.revoked,
                                issued: data.value.issued,
                                accum: data.value.accum_to.value.accum,
                                txnTime: txnTime,
                            }];
                }
            });
        });
    };
    return IndyVdrAnonCredsRegistry;
}());
exports.IndyVdrAnonCredsRegistry = IndyVdrAnonCredsRegistry;
