"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g = Object.create((typeof Iterator === "function" ? Iterator : Object).prototype);
    return g.next = verb(0), g["throw"] = verb(1), g["return"] = verb(2), typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.IndyVdrIndyDidRegistrar = void 0;
var anoncreds_1 = require("@credo-ts/anoncreds");
var core_1 = require("@credo-ts/core");
var indy_vdr_shared_1 = require("@hyperledger/indy-vdr-shared");
var error_1 = require("../error");
var IndyVdrPoolService_1 = require("../pool/IndyVdrPoolService");
var didIndyUtil_1 = require("./didIndyUtil");
var didSovUtil_1 = require("./didSovUtil");
var IndyVdrIndyDidRegistrar = /** @class */ (function () {
    function IndyVdrIndyDidRegistrar() {
        this.supportedMethods = ['indy'];
    }
    IndyVdrIndyDidRegistrar.prototype.didCreateActionResult = function (_a) {
        var namespace = _a.namespace, didAction = _a.didAction, did = _a.did;
        return {
            jobId: did,
            didDocumentMetadata: {},
            didRegistrationMetadata: {
                didIndyNamespace: namespace,
            },
            didState: didAction,
        };
    };
    IndyVdrIndyDidRegistrar.prototype.didCreateFailedResult = function (_a) {
        var reason = _a.reason;
        return {
            didDocumentMetadata: {},
            didRegistrationMetadata: {},
            didState: {
                state: 'failed',
                reason: reason,
            },
        };
    };
    IndyVdrIndyDidRegistrar.prototype.didCreateFinishedResult = function (_a) {
        var seed = _a.seed, privateKey = _a.privateKey, did = _a.did, didDocument = _a.didDocument, namespace = _a.namespace;
        return {
            didDocumentMetadata: {},
            didRegistrationMetadata: {
                didIndyNamespace: namespace,
            },
            didState: {
                state: 'finished',
                did: did,
                didDocument: didDocument,
                secret: {
                    // FIXME: the uni-registrar creates the seed in the registrar method
                    // if it doesn't exist so the seed can always be returned. Currently
                    // we can only return it if the seed was passed in by the user. Once
                    // we have a secure method for generating seeds we should use the same
                    // approach
                    seed: seed,
                    privateKey: privateKey,
                },
            },
        };
    };
    IndyVdrIndyDidRegistrar.prototype.parseInput = function (agentContext, options) {
        return __awaiter(this, void 0, void 0, function () {
            var did, namespaceIdentifier, verificationKey, seed, privateKey, _did, namespace, endorserNamespaceIdentifier_1, endorserDid, _a, endorserNamespace, endorserNamespaceIdentifier, allowOne, _b, didNamespace, didNamespaceIdentifier, buffer;
            var _c, _d;
            return __generator(this, function (_e) {
                switch (_e.label) {
                    case 0:
                        did = options.did;
                        seed = (_c = options.secret) === null || _c === void 0 ? void 0 : _c.seed;
                        privateKey = (_d = options.secret) === null || _d === void 0 ? void 0 : _d.privateKey;
                        if (options.options.endorsedTransaction) {
                            _did = did;
                            namespace = (0, anoncreds_1.parseIndyDid)(_did).namespace;
                            endorserNamespaceIdentifier_1 = JSON.parse(options.options.endorsedTransaction.nymRequest).identifier;
                            return [2 /*return*/, {
                                    status: 'ok',
                                    did: _did,
                                    namespace: namespace,
                                    namespaceIdentifier: (0, anoncreds_1.parseIndyDid)(_did).namespaceIdentifier,
                                    endorserNamespaceIdentifier: endorserNamespaceIdentifier_1,
                                    seed: seed,
                                    privateKey: privateKey,
                                }];
                        }
                        endorserDid = options.options.endorserDid;
                        _a = (0, anoncreds_1.parseIndyDid)(endorserDid), endorserNamespace = _a.namespace, endorserNamespaceIdentifier = _a.namespaceIdentifier;
                        allowOne = [privateKey, seed, did].filter(function (e) { return e !== undefined; });
                        if (allowOne.length > 1) {
                            return [2 /*return*/, {
                                    status: 'error',
                                    reason: "Only one of 'seed', 'privateKey' and 'did' must be provided",
                                }];
                        }
                        if (!did) return [3 /*break*/, 1];
                        if (!options.options.verkey) {
                            return [2 /*return*/, {
                                    status: 'error',
                                    reason: 'If a did is defined, a matching verkey must be provided',
                                }];
                        }
                        _b = (0, anoncreds_1.parseIndyDid)(did), didNamespace = _b.namespace, didNamespaceIdentifier = _b.namespaceIdentifier;
                        namespaceIdentifier = didNamespaceIdentifier;
                        verificationKey = core_1.Key.fromPublicKeyBase58(options.options.verkey, core_1.KeyType.Ed25519);
                        if (!(0, didIndyUtil_1.isSelfCertifiedIndyDid)(did, options.options.verkey)) {
                            return [2 /*return*/, {
                                    status: 'error',
                                    reason: "Initial verkey ".concat(options.options.verkey, " does not match did ").concat(did),
                                }];
                        }
                        if (didNamespace !== endorserNamespace) {
                            return [2 /*return*/, {
                                    status: 'error',
                                    reason: "The endorser did uses namespace: '".concat(endorserNamespace, "' and the did to register uses namespace: '").concat(didNamespace, "'. Namespaces must match."),
                                }];
                        }
                        return [3 /*break*/, 3];
                    case 1: return [4 /*yield*/, agentContext.wallet.createKey({ privateKey: privateKey, seed: seed, keyType: core_1.KeyType.Ed25519 })];
                    case 2:
                        // Create a new key and calculate did according to the rules for indy did method
                        verificationKey = _e.sent();
                        buffer = core_1.Hasher.hash(verificationKey.publicKey, 'sha-256');
                        namespaceIdentifier = core_1.TypedArrayEncoder.toBase58(buffer.slice(0, 16));
                        did = "did:indy:".concat(endorserNamespace, ":").concat(namespaceIdentifier);
                        _e.label = 3;
                    case 3: return [2 /*return*/, {
                            status: 'ok',
                            did: did,
                            verificationKey: verificationKey,
                            namespaceIdentifier: namespaceIdentifier,
                            namespace: endorserNamespace,
                            endorserNamespaceIdentifier: endorserNamespaceIdentifier,
                            seed: seed,
                            privateKey: privateKey,
                        }];
                }
            });
        });
    };
    IndyVdrIndyDidRegistrar.prototype.saveDidRecord = function (agentContext, did, didDocument) {
        return __awaiter(this, void 0, void 0, function () {
            var didRecord, didRepository;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        didRecord = new core_1.DidRecord({
                            did: did,
                            role: core_1.DidDocumentRole.Created,
                            didDocument: didDocument,
                        });
                        didRepository = agentContext.dependencyManager.resolve(core_1.DidRepository);
                        return [4 /*yield*/, didRepository.save(agentContext, didRecord)];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    IndyVdrIndyDidRegistrar.prototype.createDidDocument = function (did, verificationKey, services, useEndpointAttrib) {
        // Create base did document
        var didDocumentBuilder = (0, didIndyUtil_1.indyDidDocumentFromDid)(did, verificationKey.publicKeyBase58);
        var diddocContent;
        // Add services if object was passed
        if (services) {
            services.forEach(function (item) {
                var prependDidIfNotPresent = function (id) {
                    return id.startsWith('#') ? "".concat(did).concat(id) : id;
                };
                // Prepend the did to the service id if it is not already there
                item.id = prependDidIfNotPresent(item.id);
                // TODO: should we also prepend the did to routingKeys?
                if (item instanceof core_1.DidCommV1Service) {
                    item.recipientKeys = item.recipientKeys.map(prependDidIfNotPresent);
                }
                didDocumentBuilder.addService(item);
            });
            var commTypes = [core_1.IndyAgentService.type, core_1.DidCommV1Service.type, core_1.NewDidCommV2Service.type, core_1.DidCommV2Service.type];
            var serviceTypes_1 = new Set(services.map(function (item) { return item.type; }));
            var keyAgreementId = "".concat(did, "#key-agreement-1");
            // If there is at least a communication service, add the key agreement key
            if (commTypes.some(function (type) { return serviceTypes_1.has(type); })) {
                didDocumentBuilder
                    .addContext('https://w3id.org/security/suites/x25519-2019/v1')
                    .addVerificationMethod({
                    controller: did,
                    id: keyAgreementId,
                    publicKeyBase58: (0, didIndyUtil_1.createKeyAgreementKey)(verificationKey.publicKeyBase58),
                    type: 'X25519KeyAgreementKey2019',
                })
                    .addKeyAgreement(keyAgreementId);
            }
            // FIXME: it doesn't seem this context exists?
            // If there is a DIDComm V2 service, add context
            if (serviceTypes_1.has(core_1.NewDidCommV2Service.type) || serviceTypes_1.has(core_1.DidCommV2Service.type)) {
                didDocumentBuilder.addContext('https://didcomm.org/messaging/contexts/v2');
            }
            if (!useEndpointAttrib) {
                // create diddocContent parameter based on the diff between the base and the resulting DID Document
                diddocContent = (0, didIndyUtil_1.didDocDiff)(didDocumentBuilder.build().toJSON(), (0, didIndyUtil_1.indyDidDocumentFromDid)(did, verificationKey.publicKeyBase58).build().toJSON());
            }
        }
        // Build did document
        var didDocument = didDocumentBuilder.build();
        return {
            diddocContent: diddocContent,
            didDocument: didDocument,
        };
    };
    IndyVdrIndyDidRegistrar.prototype.create = function (agentContext, options) {
        return __awaiter(this, void 0, void 0, function () {
            var res, did, namespaceIdentifier, endorserNamespaceIdentifier, verificationKey, namespace, seed, privateKey, pool, nymRequest, didDocument, attribRequest, alias, _a, _nymRequest, _attribRequest, _b, services, useEndpointAttrib, _c, _didDocument, diddocContent, didRegisterSigningKey, endpoints, didAction, _d, error_2;
            return __generator(this, function (_e) {
                switch (_e.label) {
                    case 0:
                        _e.trys.push([0, 16, , 17]);
                        return [4 /*yield*/, this.parseInput(agentContext, options)];
                    case 1:
                        res = _e.sent();
                        if (res.status === 'error')
                            return [2 /*return*/, this.didCreateFailedResult({ reason: res.reason })];
                        did = res.did, namespaceIdentifier = res.namespaceIdentifier, endorserNamespaceIdentifier = res.endorserNamespaceIdentifier, verificationKey = res.verificationKey, namespace = res.namespace, seed = res.seed, privateKey = res.privateKey;
                        pool = agentContext.dependencyManager.resolve(IndyVdrPoolService_1.IndyVdrPoolService).getPoolForNamespace(namespace);
                        nymRequest = void 0;
                        didDocument = void 0;
                        attribRequest = void 0;
                        alias = void 0;
                        if (!options.options.endorsedTransaction) return [3 /*break*/, 2];
                        _a = options.options.endorsedTransaction, _nymRequest = _a.nymRequest, _attribRequest = _a.attribRequest;
                        nymRequest = new indy_vdr_shared_1.CustomRequest({ customRequest: _nymRequest });
                        attribRequest = _attribRequest ? new indy_vdr_shared_1.CustomRequest({ customRequest: _attribRequest }) : undefined;
                        return [3 /*break*/, 8];
                    case 2:
                        _b = options.options, services = _b.services, useEndpointAttrib = _b.useEndpointAttrib;
                        alias = options.options.alias;
                        if (!verificationKey)
                            throw new Error('VerificationKey not defined');
                        _c = this.createDidDocument(did, verificationKey, services, useEndpointAttrib), _didDocument = _c.didDocument, diddocContent = _c.diddocContent;
                        didDocument = _didDocument;
                        didRegisterSigningKey = undefined;
                        if (!(options.options.endorserMode === 'internal')) return [3 /*break*/, 4];
                        return [4 /*yield*/, (0, didIndyUtil_1.verificationKeyForIndyDid)(agentContext, options.options.endorserDid)];
                    case 3:
                        didRegisterSigningKey = _e.sent();
                        _e.label = 4;
                    case 4: return [4 /*yield*/, this.createRegisterDidWriteRequest({
                            agentContext: agentContext,
                            pool: pool,
                            signingKey: didRegisterSigningKey,
                            submitterNamespaceIdentifier: endorserNamespaceIdentifier,
                            namespaceIdentifier: namespaceIdentifier,
                            verificationKey: verificationKey,
                            alias: alias,
                            diddocContent: diddocContent,
                            role: options.options.role,
                        })];
                    case 5:
                        nymRequest = _e.sent();
                        if (!(services && useEndpointAttrib)) return [3 /*break*/, 7];
                        endpoints = (0, didSovUtil_1.endpointsAttribFromServices)(services);
                        return [4 /*yield*/, this.createSetDidEndpointsRequest({
                                agentContext: agentContext,
                                pool: pool,
                                signingKey: verificationKey,
                                endorserDid: options.options.endorserMode === 'external' ? options.options.endorserDid : undefined,
                                unqualifiedDid: namespaceIdentifier,
                                endpoints: endpoints,
                            })];
                    case 6:
                        attribRequest = _e.sent();
                        _e.label = 7;
                    case 7:
                        if (options.options.endorserMode === 'external') {
                            didAction = {
                                state: 'action',
                                action: 'endorseIndyTransaction',
                                endorserDid: options.options.endorserDid,
                                nymRequest: nymRequest.body,
                                attribRequest: attribRequest === null || attribRequest === void 0 ? void 0 : attribRequest.body,
                                did: did,
                                secret: { seed: seed, privateKey: privateKey },
                            };
                            return [2 /*return*/, this.didCreateActionResult({ namespace: namespace, didAction: didAction, did: did })];
                        }
                        _e.label = 8;
                    case 8: return [4 /*yield*/, this.registerPublicDid(agentContext, pool, nymRequest)];
                    case 9:
                        _e.sent();
                        if (!attribRequest) return [3 /*break*/, 11];
                        return [4 /*yield*/, this.setEndpointsForDid(agentContext, pool, attribRequest)];
                    case 10:
                        _e.sent();
                        _e.label = 11;
                    case 11:
                        if (!(didDocument !== null && didDocument !== void 0)) return [3 /*break*/, 12];
                        _d = didDocument;
                        return [3 /*break*/, 14];
                    case 12: return [4 /*yield*/, (0, didIndyUtil_1.buildDidDocument)(agentContext, pool, did)];
                    case 13:
                        _d = (_e.sent());
                        _e.label = 14;
                    case 14:
                        didDocument = _d;
                        return [4 /*yield*/, this.saveDidRecord(agentContext, did, didDocument)];
                    case 15:
                        _e.sent();
                        return [2 /*return*/, this.didCreateFinishedResult({ did: did, didDocument: didDocument, namespace: namespace, seed: seed, privateKey: privateKey })];
                    case 16:
                        error_2 = _e.sent();
                        return [2 /*return*/, this.didCreateFailedResult({ reason: "unknownError: ".concat(error_2.message) })];
                    case 17: return [2 /*return*/];
                }
            });
        });
    };
    IndyVdrIndyDidRegistrar.prototype.update = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, {
                        didDocumentMetadata: {},
                        didRegistrationMetadata: {},
                        didState: {
                            state: 'failed',
                            reason: "notImplemented: updating did:indy not implemented yet",
                        },
                    }];
            });
        });
    };
    IndyVdrIndyDidRegistrar.prototype.deactivate = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, {
                        didDocumentMetadata: {},
                        didRegistrationMetadata: {},
                        didState: {
                            state: 'failed',
                            reason: "notImplemented: deactivating did:indy not implemented yet",
                        },
                    }];
            });
        });
    };
    IndyVdrIndyDidRegistrar.prototype.createRegisterDidWriteRequest = function (options) {
        return __awaiter(this, void 0, void 0, function () {
            var agentContext, pool, submitterNamespaceIdentifier, namespaceIdentifier, verificationKey, alias, signingKey, role, request, writeRequest;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        agentContext = options.agentContext, pool = options.pool, submitterNamespaceIdentifier = options.submitterNamespaceIdentifier, namespaceIdentifier = options.namespaceIdentifier, verificationKey = options.verificationKey, alias = options.alias, signingKey = options.signingKey, role = options.role;
                        // FIXME: Add diddocContent when supported by indy-vdr
                        if (options.diddocContent) {
                            throw new error_1.IndyVdrError('diddocContent is not yet supported');
                        }
                        request = new indy_vdr_shared_1.NymRequest({
                            submitterDid: submitterNamespaceIdentifier,
                            dest: namespaceIdentifier,
                            verkey: verificationKey.publicKeyBase58,
                            alias: alias,
                            role: role,
                        });
                        if (!signingKey)
                            return [2 /*return*/, request];
                        return [4 /*yield*/, pool.prepareWriteRequest(agentContext, request, signingKey, undefined)];
                    case 1:
                        writeRequest = _a.sent();
                        return [2 /*return*/, writeRequest];
                }
            });
        });
    };
    IndyVdrIndyDidRegistrar.prototype.registerPublicDid = function (agentContext, pool, writeRequest) {
        return __awaiter(this, void 0, void 0, function () {
            var body, response, error_3;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        body = writeRequest.body;
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, pool.submitRequest(writeRequest)];
                    case 2:
                        response = _a.sent();
                        agentContext.config.logger.debug("Register public did on ledger '".concat(pool.indyNamespace, "'\nRequest: ").concat(body, "}"), {
                            response: response,
                        });
                        return [2 /*return*/];
                    case 3:
                        error_3 = _a.sent();
                        agentContext.config.logger.error("Error Registering public did on ledger '".concat(pool.indyNamespace, "'\nRequest: ").concat(body, "}"));
                        throw error_3;
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    IndyVdrIndyDidRegistrar.prototype.createSetDidEndpointsRequest = function (options) {
        return __awaiter(this, void 0, void 0, function () {
            var agentContext, pool, endpoints, unqualifiedDid, signingKey, endorserDid, request, writeRequest;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        agentContext = options.agentContext, pool = options.pool, endpoints = options.endpoints, unqualifiedDid = options.unqualifiedDid, signingKey = options.signingKey, endorserDid = options.endorserDid;
                        request = new indy_vdr_shared_1.AttribRequest({
                            submitterDid: unqualifiedDid,
                            targetDid: unqualifiedDid,
                            raw: JSON.stringify({ endpoint: endpoints }),
                        });
                        return [4 /*yield*/, pool.prepareWriteRequest(agentContext, request, signingKey, endorserDid)];
                    case 1:
                        writeRequest = _a.sent();
                        return [2 /*return*/, writeRequest];
                }
            });
        });
    };
    IndyVdrIndyDidRegistrar.prototype.setEndpointsForDid = function (agentContext, pool, writeRequest) {
        return __awaiter(this, void 0, void 0, function () {
            var body, response, error_4;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        body = writeRequest.body;
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, pool.submitRequest(writeRequest)];
                    case 2:
                        response = _a.sent();
                        agentContext.config.logger.debug("Successfully set endpoints for did on ledger '".concat(pool.indyNamespace, "'.\nRequest: ").concat(body, "}"), {
                            response: response,
                        });
                        return [3 /*break*/, 4];
                    case 3:
                        error_4 = _a.sent();
                        agentContext.config.logger.error("Error setting endpoints for did on ledger '".concat(pool.indyNamespace, "'.\nRequest: ").concat(body, "}"));
                        throw new error_1.IndyVdrError(error_4);
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    return IndyVdrIndyDidRegistrar;
}());
exports.IndyVdrIndyDidRegistrar = IndyVdrIndyDidRegistrar;
