"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g = Object.create((typeof Iterator === "function" ? Iterator : Object).prototype);
    return g.next = verb(0), g["throw"] = verb(1), g["return"] = verb(2), typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@credo-ts/core");
var rxjs_1 = require("rxjs");
var InMemoryStorageService_1 = require("../../../../../tests/InMemoryStorageService");
var InMemoryWallet_1 = require("../../../../../tests/InMemoryWallet");
var tests_1 = require("../../../../core/tests");
var pool_1 = require("../../pool");
var IndyVdrIndyDidRegistrar_1 = require("../IndyVdrIndyDidRegistrar");
jest.mock('../../pool/IndyVdrPool');
var IndyVdrPoolMock = pool_1.IndyVdrPool;
var poolMock = new IndyVdrPoolMock();
(0, tests_1.mockProperty)(poolMock, 'indyNamespace', 'ns1');
var agentConfig = (0, tests_1.getAgentConfig)('IndyVdrIndyDidRegistrar');
var wallet = new InMemoryWallet_1.InMemoryWallet();
jest
    .spyOn(wallet, 'createKey')
    .mockResolvedValue(core_1.Key.fromPublicKeyBase58('E6D1m3eERqCueX4ZgMCY14B4NceAr6XP2HyVqt55gDhu', core_1.KeyType.Ed25519));
var storageService = new InMemoryStorageService_1.InMemoryStorageService();
var eventEmitter = new core_1.EventEmitter(tests_1.agentDependencies, new rxjs_1.Subject());
var didRepository = new core_1.DidRepository(storageService, eventEmitter);
var agentContext = (0, tests_1.getAgentContext)({
    wallet: wallet,
    registerInstances: [
        [core_1.DidRepository, didRepository],
        [pool_1.IndyVdrPoolService, { getPoolForNamespace: jest.fn().mockReturnValue(poolMock) }],
        [
            core_1.DidsApi,
            {
                resolve: jest.fn().mockResolvedValue({
                    didDocument: new core_1.DidDocument({
                        id: 'did:indy:pool1:BzCbsNYhMrjHiqZDTUASHg',
                        authentication: [
                            new core_1.VerificationMethod({
                                id: 'did:indy:pool1:BzCbsNYhMrjHiqZDTUASHg#verkey',
                                type: 'Ed25519VerificationKey2018',
                                controller: 'did:indy:pool1:BzCbsNYhMrjHiqZDTUASHg',
                                publicKeyBase58: 'E6D1m3eERqCueX4ZgMCY14B4NceAr6XP2HyVqt55gDhu',
                            }),
                        ],
                    }),
                }),
            },
        ],
    ],
    agentConfig: agentConfig,
});
var indyVdrIndyDidRegistrar = new IndyVdrIndyDidRegistrar_1.IndyVdrIndyDidRegistrar();
describe('IndyVdrIndyDidRegistrar', function () {
    afterEach(function () {
        jest.clearAllMocks();
    });
    test('returns an error state if both did and privateKey are provided', function () { return __awaiter(void 0, void 0, void 0, function () {
        var result;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, indyVdrIndyDidRegistrar.create(agentContext, {
                        did: 'did:indy:pool1:did-value',
                        options: {
                            alias: 'Hello',
                            endorserMode: 'internal',
                            endorserDid: 'did:indy:pool1:BzCbsNYhMrjHiqZDTUASHg',
                        },
                        secret: {
                            privateKey: core_1.TypedArrayEncoder.fromString('key'),
                        },
                    })];
                case 1:
                    result = _a.sent();
                    expect(core_1.JsonTransformer.toJSON(result)).toMatchObject({
                        didDocumentMetadata: {},
                        didRegistrationMetadata: {},
                        didState: {
                            state: 'failed',
                            reason: "Only one of 'seed', 'privateKey' and 'did' must be provided",
                        },
                    });
                    return [2 /*return*/];
            }
        });
    }); });
    test('returns an error state if the endorser did is not a valid did:indy did', function () { return __awaiter(void 0, void 0, void 0, function () {
        var result;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, indyVdrIndyDidRegistrar.create(agentContext, {
                        method: 'indy',
                        options: {
                            endorserMode: 'internal',
                            endorserDid: 'BzCbsNYhMrjHiqZDTUASHg',
                            alias: 'Hello',
                        },
                    })];
                case 1:
                    result = _a.sent();
                    expect(core_1.JsonTransformer.toJSON(result)).toMatchObject({
                        didDocumentMetadata: {},
                        didRegistrationMetadata: {},
                        didState: {
                            state: 'failed',
                            reason: 'unknownError: BzCbsNYhMrjHiqZDTUASHg is not a valid did:indy did',
                        },
                    });
                    return [2 /*return*/];
            }
        });
    }); });
    test('returns an error state if did is provided, but it is not a valid did:indy did', function () { return __awaiter(void 0, void 0, void 0, function () {
        var result;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, indyVdrIndyDidRegistrar.create(agentContext, {
                        did: 'BzCbsNYhMrjHiqZDTUASHg',
                        options: {
                            endorserMode: 'internal',
                            endorserDid: 'did:indy:pool1:BzCbsNYhMrjHiqZDTUASHg',
                            verkey: 'verkey',
                            alias: 'Hello',
                        },
                    })];
                case 1:
                    result = _a.sent();
                    expect(core_1.JsonTransformer.toJSON(result)).toMatchObject({
                        didDocumentMetadata: {},
                        didRegistrationMetadata: {},
                        didState: {
                            state: 'failed',
                            reason: 'unknownError: BzCbsNYhMrjHiqZDTUASHg is not a valid did:indy did',
                        },
                    });
                    return [2 /*return*/];
            }
        });
    }); });
    test('returns an error state if did is provided, but no verkey', function () { return __awaiter(void 0, void 0, void 0, function () {
        var result;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, indyVdrIndyDidRegistrar.create(agentContext, {
                        did: 'BzCbsNYhMrjHiqZDTUASHg',
                        options: {
                            endorserMode: 'internal',
                            endorserDid: 'did:indy:pool1:BzCbsNYhMrjHiqZDTUASHg',
                            alias: 'Hello',
                        },
                    })];
                case 1:
                    result = _a.sent();
                    expect(core_1.JsonTransformer.toJSON(result)).toMatchObject({
                        didDocumentMetadata: {},
                        didRegistrationMetadata: {},
                        didState: {
                            state: 'failed',
                            reason: 'If a did is defined, a matching verkey must be provided',
                        },
                    });
                    return [2 /*return*/];
            }
        });
    }); });
    test('returns an error state if did and verkey are provided, but the did is not self certifying', function () { return __awaiter(void 0, void 0, void 0, function () {
        var result;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, indyVdrIndyDidRegistrar.create(agentContext, {
                        did: 'did:indy:pool1:BzCbsNYhMrjHiqZDTUASHg',
                        options: {
                            endorserMode: 'internal',
                            endorserDid: 'did:indy:pool1:BzCbsNYhMrjHiqZDTUASHg',
                            verkey: 'verkey',
                            alias: 'Hello',
                        },
                    })];
                case 1:
                    result = _a.sent();
                    expect(core_1.JsonTransformer.toJSON(result)).toMatchObject({
                        didDocumentMetadata: {},
                        didRegistrationMetadata: {},
                        didState: {
                            state: 'failed',
                            reason: 'Initial verkey verkey does not match did did:indy:pool1:BzCbsNYhMrjHiqZDTUASHg',
                        },
                    });
                    return [2 /*return*/];
            }
        });
    }); });
    test('returns an error state if did is provided, but does not match with the namespace from the endorserDid', function () { return __awaiter(void 0, void 0, void 0, function () {
        var result;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, indyVdrIndyDidRegistrar.create(agentContext, {
                        did: 'did:indy:pool2:B6xaJg1c2xU3D9ppCtt1CZ',
                        options: {
                            endorserMode: 'internal',
                            endorserDid: 'did:indy:pool1:BzCbsNYhMrjHiqZDTUASHg',
                            verkey: 'E6D1m3eERqCueX4ZgMCY14B4NceAr6XP2HyVqt55gDhu',
                            alias: 'Hello',
                        },
                    })];
                case 1:
                    result = _a.sent();
                    expect(core_1.JsonTransformer.toJSON(result)).toMatchObject({
                        didDocumentMetadata: {},
                        didRegistrationMetadata: {},
                        didState: {
                            state: 'failed',
                            reason: "The endorser did uses namespace: 'pool1' and the did to register uses namespace: 'pool2'. Namespaces must match.",
                        },
                    });
                    return [2 /*return*/];
            }
        });
    }); });
    test('creates a did:indy document without services', function () { return __awaiter(void 0, void 0, void 0, function () {
        var privateKey, createRegisterDidWriteRequest, registerPublicDidSpy, result;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    privateKey = core_1.TypedArrayEncoder.fromString('96213c3d7fc8d4d6754c712fd969598e');
                    createRegisterDidWriteRequest = jest.spyOn(indyVdrIndyDidRegistrar, 'createRegisterDidWriteRequest');
                    // @ts-ignore type check fails because method is private
                    createRegisterDidWriteRequest.mockImplementationOnce(function () { return Promise.resolve(); });
                    registerPublicDidSpy = jest.spyOn(indyVdrIndyDidRegistrar, 'registerPublicDid');
                    // @ts-ignore type check fails because method is private
                    registerPublicDidSpy.mockImplementationOnce(function () { return Promise.resolve(); });
                    return [4 /*yield*/, indyVdrIndyDidRegistrar.create(agentContext, {
                            method: 'indy',
                            options: {
                                alias: 'Hello',
                                endorserMode: 'internal',
                                endorserDid: 'did:indy:pool1:BzCbsNYhMrjHiqZDTUASHg',
                                role: 'STEWARD',
                            },
                            secret: {
                                privateKey: privateKey,
                            },
                        })];
                case 1:
                    result = _a.sent();
                    expect(createRegisterDidWriteRequest).toHaveBeenCalledWith({
                        agentContext: agentContext,
                        pool: poolMock,
                        signingKey: expect.any(core_1.Key),
                        submitterNamespaceIdentifier: 'BzCbsNYhMrjHiqZDTUASHg',
                        namespaceIdentifier: 'B6xaJg1c2xU3D9ppCtt1CZ',
                        verificationKey: expect.any(core_1.Key),
                        alias: 'Hello',
                        diddocContent: undefined,
                        role: 'STEWARD',
                    });
                    expect(registerPublicDidSpy).toHaveBeenCalledWith(agentContext, poolMock, undefined);
                    expect(core_1.JsonTransformer.toJSON(result)).toMatchObject({
                        didDocumentMetadata: {},
                        didRegistrationMetadata: {},
                        didState: {
                            state: 'finished',
                            did: 'did:indy:pool1:B6xaJg1c2xU3D9ppCtt1CZ',
                            didDocument: {
                                '@context': ['https://w3id.org/did/v1', 'https://w3id.org/security/suites/ed25519-2018/v1'],
                                id: 'did:indy:pool1:B6xaJg1c2xU3D9ppCtt1CZ',
                                verificationMethod: [
                                    {
                                        id: 'did:indy:pool1:B6xaJg1c2xU3D9ppCtt1CZ#verkey',
                                        type: 'Ed25519VerificationKey2018',
                                        controller: 'did:indy:pool1:B6xaJg1c2xU3D9ppCtt1CZ',
                                        publicKeyBase58: 'E6D1m3eERqCueX4ZgMCY14B4NceAr6XP2HyVqt55gDhu',
                                    },
                                ],
                                authentication: ['did:indy:pool1:B6xaJg1c2xU3D9ppCtt1CZ#verkey'],
                                assertionMethod: undefined,
                                keyAgreement: undefined,
                            },
                            secret: {
                                privateKey: privateKey,
                            },
                        },
                    });
                    return [2 /*return*/];
            }
        });
    }); });
    test('creates a did:indy document by passing did', function () { return __awaiter(void 0, void 0, void 0, function () {
        var createRegisterDidWriteRequest, registerPublicDidSpy, result;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    createRegisterDidWriteRequest = jest.spyOn(indyVdrIndyDidRegistrar, 'createRegisterDidWriteRequest');
                    // @ts-ignore type check fails because method is private
                    createRegisterDidWriteRequest.mockImplementationOnce(function () { return Promise.resolve(); });
                    registerPublicDidSpy = jest.spyOn(indyVdrIndyDidRegistrar, 'registerPublicDid');
                    // @ts-ignore type check fails because method is private
                    registerPublicDidSpy.mockImplementationOnce(function () { return Promise.resolve(); });
                    return [4 /*yield*/, indyVdrIndyDidRegistrar.create(agentContext, {
                            did: 'did:indy:pool1:B6xaJg1c2xU3D9ppCtt1CZ',
                            options: {
                                verkey: 'E6D1m3eERqCueX4ZgMCY14B4NceAr6XP2HyVqt55gDhu',
                                alias: 'Hello',
                                endorserMode: 'internal',
                                endorserDid: 'did:indy:pool1:BzCbsNYhMrjHiqZDTUASHg',
                                role: 'STEWARD',
                            },
                            secret: {},
                        })];
                case 1:
                    result = _a.sent();
                    expect(createRegisterDidWriteRequest).toHaveBeenCalledWith({
                        agentContext: agentContext,
                        pool: poolMock,
                        signingKey: expect.any(core_1.Key),
                        submitterNamespaceIdentifier: 'BzCbsNYhMrjHiqZDTUASHg',
                        namespaceIdentifier: 'B6xaJg1c2xU3D9ppCtt1CZ',
                        verificationKey: expect.any(core_1.Key),
                        alias: 'Hello',
                        diddocContent: undefined,
                        role: 'STEWARD',
                    });
                    expect(registerPublicDidSpy).toHaveBeenCalledWith(agentContext, poolMock, 
                    // writeRequest
                    undefined);
                    expect(core_1.JsonTransformer.toJSON(result)).toMatchObject({
                        didDocumentMetadata: {},
                        didRegistrationMetadata: {},
                        didState: {
                            state: 'finished',
                            did: 'did:indy:pool1:B6xaJg1c2xU3D9ppCtt1CZ',
                            didDocument: {
                                '@context': ['https://w3id.org/did/v1', 'https://w3id.org/security/suites/ed25519-2018/v1'],
                                id: 'did:indy:pool1:B6xaJg1c2xU3D9ppCtt1CZ',
                                verificationMethod: [
                                    {
                                        id: 'did:indy:pool1:B6xaJg1c2xU3D9ppCtt1CZ#verkey',
                                        type: 'Ed25519VerificationKey2018',
                                        controller: 'did:indy:pool1:B6xaJg1c2xU3D9ppCtt1CZ',
                                        publicKeyBase58: 'E6D1m3eERqCueX4ZgMCY14B4NceAr6XP2HyVqt55gDhu',
                                    },
                                ],
                                authentication: ['did:indy:pool1:B6xaJg1c2xU3D9ppCtt1CZ#verkey'],
                                assertionMethod: undefined,
                                keyAgreement: undefined,
                            },
                            secret: {},
                        },
                    });
                    return [2 /*return*/];
            }
        });
    }); });
    test('creates a did:indy document with services using diddocContent', function () { return __awaiter(void 0, void 0, void 0, function () {
        var privateKey, createRegisterDidWriteRequestSpy, registerPublicDidSpy, setEndpointsForDidSpy, result;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    privateKey = core_1.TypedArrayEncoder.fromString('96213c3d7fc8d4d6754c712fd969598e');
                    createRegisterDidWriteRequestSpy = jest.spyOn(indyVdrIndyDidRegistrar, 'createRegisterDidWriteRequest');
                    // @ts-ignore type check fails because method is private
                    createRegisterDidWriteRequestSpy.mockImplementationOnce(function () { return Promise.resolve(); });
                    registerPublicDidSpy = jest.spyOn(indyVdrIndyDidRegistrar, 'registerPublicDid');
                    // @ts-ignore type check fails because method is private
                    registerPublicDidSpy.mockImplementationOnce(function () { return Promise.resolve(); });
                    setEndpointsForDidSpy = jest.spyOn(indyVdrIndyDidRegistrar, 'setEndpointsForDid');
                    return [4 /*yield*/, indyVdrIndyDidRegistrar.create(agentContext, {
                            method: 'indy',
                            options: {
                                alias: 'Hello',
                                endorserMode: 'internal',
                                endorserDid: 'did:indy:pool1:BzCbsNYhMrjHiqZDTUASHg',
                                role: 'STEWARD',
                                services: [
                                    new core_1.DidDocumentService({
                                        id: "#endpoint",
                                        serviceEndpoint: 'https://example.com/endpoint',
                                        type: 'endpoint',
                                    }),
                                    new core_1.DidCommV1Service({
                                        id: "#did-communication",
                                        priority: 0,
                                        recipientKeys: ["#key-agreement-1"],
                                        routingKeys: ['key-1'],
                                        serviceEndpoint: 'https://example.com/endpoint',
                                        accept: ['didcomm/aip2;env=rfc19'],
                                    }),
                                    new core_1.NewDidCommV2Service({
                                        id: "#didcomm-messaging-1",
                                        serviceEndpoint: new core_1.NewDidCommV2ServiceEndpoint({
                                            accept: ['didcomm/v2'],
                                            routingKeys: ['key-1'],
                                            uri: 'https://example.com/endpoint',
                                        }),
                                    }),
                                ],
                            },
                            secret: {
                                privateKey: privateKey,
                            },
                        })];
                case 1:
                    result = _a.sent();
                    expect(createRegisterDidWriteRequestSpy).toHaveBeenCalledWith({
                        agentContext: agentContext,
                        pool: poolMock,
                        signingKey: expect.any(core_1.Key),
                        submitterNamespaceIdentifier: 'BzCbsNYhMrjHiqZDTUASHg',
                        namespaceIdentifier: 'B6xaJg1c2xU3D9ppCtt1CZ',
                        verificationKey: expect.any(core_1.Key),
                        alias: 'Hello',
                        role: 'STEWARD',
                        diddocContent: {
                            '@context': [],
                            authentication: [],
                            id: 'did:indy:pool1:B6xaJg1c2xU3D9ppCtt1CZ',
                            keyAgreement: ['did:indy:pool1:B6xaJg1c2xU3D9ppCtt1CZ#key-agreement-1'],
                            service: [
                                {
                                    id: 'did:indy:pool1:B6xaJg1c2xU3D9ppCtt1CZ#endpoint',
                                    serviceEndpoint: 'https://example.com/endpoint',
                                    type: 'endpoint',
                                },
                                {
                                    accept: ['didcomm/aip2;env=rfc19'],
                                    id: 'did:indy:pool1:B6xaJg1c2xU3D9ppCtt1CZ#did-communication',
                                    priority: 0,
                                    recipientKeys: ['did:indy:pool1:B6xaJg1c2xU3D9ppCtt1CZ#key-agreement-1'],
                                    routingKeys: ['key-1'],
                                    serviceEndpoint: 'https://example.com/endpoint',
                                    type: 'did-communication',
                                },
                                {
                                    id: 'did:indy:pool1:B6xaJg1c2xU3D9ppCtt1CZ#didcomm-messaging-1',
                                    serviceEndpoint: {
                                        uri: 'https://example.com/endpoint',
                                        accept: ['didcomm/v2'],
                                        routingKeys: ['key-1'],
                                    },
                                    type: 'DIDCommMessaging',
                                },
                            ],
                            verificationMethod: [
                                {
                                    controller: 'did:indy:pool1:B6xaJg1c2xU3D9ppCtt1CZ',
                                    id: 'did:indy:pool1:B6xaJg1c2xU3D9ppCtt1CZ#key-agreement-1',
                                    publicKeyBase58: 'Fbv17ZbnUSbafsiUBJbdGeC62M8v8GEscVMMcE59mRPt',
                                    type: 'X25519KeyAgreementKey2019',
                                },
                            ],
                        },
                    });
                    expect(registerPublicDidSpy).toHaveBeenCalledWith(agentContext, poolMock, 
                    // writeRequest
                    undefined);
                    expect(setEndpointsForDidSpy).not.toHaveBeenCalled();
                    expect(core_1.JsonTransformer.toJSON(result)).toMatchObject({
                        didDocumentMetadata: {},
                        didRegistrationMetadata: {},
                        didState: {
                            state: 'finished',
                            did: 'did:indy:pool1:B6xaJg1c2xU3D9ppCtt1CZ',
                            didDocument: {
                                '@context': [
                                    'https://w3id.org/did/v1',
                                    'https://w3id.org/security/suites/ed25519-2018/v1',
                                    'https://w3id.org/security/suites/x25519-2019/v1',
                                    'https://didcomm.org/messaging/contexts/v2',
                                ],
                                id: 'did:indy:pool1:B6xaJg1c2xU3D9ppCtt1CZ',
                                verificationMethod: [
                                    {
                                        id: 'did:indy:pool1:B6xaJg1c2xU3D9ppCtt1CZ#verkey',
                                        type: 'Ed25519VerificationKey2018',
                                        controller: 'did:indy:pool1:B6xaJg1c2xU3D9ppCtt1CZ',
                                        publicKeyBase58: 'E6D1m3eERqCueX4ZgMCY14B4NceAr6XP2HyVqt55gDhu',
                                    },
                                    {
                                        id: 'did:indy:pool1:B6xaJg1c2xU3D9ppCtt1CZ#key-agreement-1',
                                        type: 'X25519KeyAgreementKey2019',
                                        controller: 'did:indy:pool1:B6xaJg1c2xU3D9ppCtt1CZ',
                                        publicKeyBase58: 'Fbv17ZbnUSbafsiUBJbdGeC62M8v8GEscVMMcE59mRPt',
                                    },
                                ],
                                service: [
                                    {
                                        id: 'did:indy:pool1:B6xaJg1c2xU3D9ppCtt1CZ#endpoint',
                                        serviceEndpoint: 'https://example.com/endpoint',
                                        type: 'endpoint',
                                    },
                                    {
                                        id: 'did:indy:pool1:B6xaJg1c2xU3D9ppCtt1CZ#did-communication',
                                        serviceEndpoint: 'https://example.com/endpoint',
                                        type: 'did-communication',
                                        priority: 0,
                                        recipientKeys: ['did:indy:pool1:B6xaJg1c2xU3D9ppCtt1CZ#key-agreement-1'],
                                        routingKeys: ['key-1'],
                                        accept: ['didcomm/aip2;env=rfc19'],
                                    },
                                    {
                                        id: 'did:indy:pool1:B6xaJg1c2xU3D9ppCtt1CZ#didcomm-messaging-1',
                                        type: 'DIDCommMessaging',
                                        serviceEndpoint: {
                                            uri: 'https://example.com/endpoint',
                                            routingKeys: ['key-1'],
                                            accept: ['didcomm/v2'],
                                        },
                                    },
                                ],
                                authentication: ['did:indy:pool1:B6xaJg1c2xU3D9ppCtt1CZ#verkey'],
                                assertionMethod: undefined,
                                keyAgreement: ['did:indy:pool1:B6xaJg1c2xU3D9ppCtt1CZ#key-agreement-1'],
                            },
                            secret: {
                                privateKey: privateKey,
                            },
                        },
                    });
                    return [2 /*return*/];
            }
        });
    }); });
    test('creates a did:indy document with services using attrib', function () { return __awaiter(void 0, void 0, void 0, function () {
        var privateKey, createRegisterDidWriteRequestSpy, registerPublicDidSpy, createSetDidEndpointsRequestSpy, setEndpointsForDidSpy, result;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    privateKey = core_1.TypedArrayEncoder.fromString('96213c3d7fc8d4d6754c712fd969598e');
                    createRegisterDidWriteRequestSpy = jest.spyOn(indyVdrIndyDidRegistrar, 'createRegisterDidWriteRequest');
                    // @ts-ignore type check fails because method is private
                    createRegisterDidWriteRequestSpy.mockImplementationOnce(function () { return Promise.resolve(); });
                    registerPublicDidSpy = jest.spyOn(indyVdrIndyDidRegistrar, 'registerPublicDid');
                    // @ts-ignore type check fails because method is private
                    registerPublicDidSpy.mockImplementationOnce(function () { return Promise.resolve(); });
                    createSetDidEndpointsRequestSpy = jest.spyOn(indyVdrIndyDidRegistrar, 'createSetDidEndpointsRequest');
                    // @ts-ignore type check fails because method is private
                    createSetDidEndpointsRequestSpy.mockImplementationOnce(function () { return Promise.resolve(undefined); });
                    setEndpointsForDidSpy = jest.spyOn(indyVdrIndyDidRegistrar, 'setEndpointsForDid');
                    // @ts-ignore type check fails because method is private
                    setEndpointsForDidSpy.mockImplementationOnce(function () { return Promise.resolve(undefined); });
                    return [4 /*yield*/, indyVdrIndyDidRegistrar.create(agentContext, {
                            method: 'indy',
                            options: {
                                alias: 'Hello',
                                endorserMode: 'internal',
                                endorserDid: 'did:indy:pool1:BzCbsNYhMrjHiqZDTUASHg',
                                role: 'STEWARD',
                                useEndpointAttrib: true,
                                services: [
                                    new core_1.DidDocumentService({
                                        id: "#endpoint",
                                        serviceEndpoint: 'https://example.com/endpoint',
                                        type: 'endpoint',
                                    }),
                                    new core_1.DidCommV1Service({
                                        id: "#did-communication",
                                        priority: 0,
                                        recipientKeys: ["#key-agreement-1"],
                                        routingKeys: ['key-1'],
                                        serviceEndpoint: 'https://example.com/endpoint',
                                        accept: ['didcomm/aip2;env=rfc19'],
                                    }),
                                    new core_1.NewDidCommV2Service({
                                        id: "#didcomm-messaging-1",
                                        serviceEndpoint: new core_1.NewDidCommV2ServiceEndpoint({
                                            accept: ['didcomm/v2'],
                                            routingKeys: ['key-1'],
                                            uri: 'https://example.com/endpoint',
                                        }),
                                    }),
                                ],
                            },
                            secret: {
                                privateKey: privateKey,
                            },
                        })];
                case 1:
                    result = _a.sent();
                    expect(result.didState.state).toEqual('finished');
                    expect(createRegisterDidWriteRequestSpy).toHaveBeenCalledWith({
                        agentContext: agentContext,
                        pool: poolMock,
                        signingKey: expect.any(core_1.Key),
                        submitterNamespaceIdentifier: 'BzCbsNYhMrjHiqZDTUASHg',
                        namespaceIdentifier: 'B6xaJg1c2xU3D9ppCtt1CZ',
                        verificationKey: expect.any(core_1.Key),
                        alias: 'Hello',
                        diddocContent: undefined,
                        role: 'STEWARD',
                    });
                    expect(registerPublicDidSpy).toHaveBeenCalledWith(agentContext, poolMock, 
                    // writeRequest
                    undefined);
                    expect(createSetDidEndpointsRequestSpy).toHaveBeenCalledWith({
                        agentContext: agentContext,
                        pool: poolMock,
                        signingKey: expect.any(core_1.Key),
                        endorserDid: undefined,
                        // Unqualified created indy did
                        unqualifiedDid: 'B6xaJg1c2xU3D9ppCtt1CZ',
                        endpoints: {
                            endpoint: 'https://example.com/endpoint',
                            routingKeys: ['key-1'],
                            types: ['endpoint', 'did-communication', 'DIDCommMessaging'],
                        },
                    });
                    expect(setEndpointsForDidSpy).not.toHaveBeenCalled();
                    expect(core_1.JsonTransformer.toJSON(result)).toMatchObject({
                        didDocumentMetadata: {},
                        didRegistrationMetadata: {},
                        didState: {
                            state: 'finished',
                            did: 'did:indy:pool1:B6xaJg1c2xU3D9ppCtt1CZ',
                            didDocument: {
                                '@context': [
                                    'https://w3id.org/did/v1',
                                    'https://w3id.org/security/suites/ed25519-2018/v1',
                                    'https://w3id.org/security/suites/x25519-2019/v1',
                                    'https://didcomm.org/messaging/contexts/v2',
                                ],
                                id: 'did:indy:pool1:B6xaJg1c2xU3D9ppCtt1CZ',
                                verificationMethod: [
                                    {
                                        id: 'did:indy:pool1:B6xaJg1c2xU3D9ppCtt1CZ#verkey',
                                        type: 'Ed25519VerificationKey2018',
                                        controller: 'did:indy:pool1:B6xaJg1c2xU3D9ppCtt1CZ',
                                        publicKeyBase58: 'E6D1m3eERqCueX4ZgMCY14B4NceAr6XP2HyVqt55gDhu',
                                    },
                                    {
                                        id: 'did:indy:pool1:B6xaJg1c2xU3D9ppCtt1CZ#key-agreement-1',
                                        type: 'X25519KeyAgreementKey2019',
                                        controller: 'did:indy:pool1:B6xaJg1c2xU3D9ppCtt1CZ',
                                        publicKeyBase58: 'Fbv17ZbnUSbafsiUBJbdGeC62M8v8GEscVMMcE59mRPt',
                                    },
                                ],
                                service: [
                                    {
                                        id: 'did:indy:pool1:B6xaJg1c2xU3D9ppCtt1CZ#endpoint',
                                        serviceEndpoint: 'https://example.com/endpoint',
                                        type: 'endpoint',
                                    },
                                    {
                                        id: 'did:indy:pool1:B6xaJg1c2xU3D9ppCtt1CZ#did-communication',
                                        serviceEndpoint: 'https://example.com/endpoint',
                                        type: 'did-communication',
                                        priority: 0,
                                        recipientKeys: ['did:indy:pool1:B6xaJg1c2xU3D9ppCtt1CZ#key-agreement-1'],
                                        routingKeys: ['key-1'],
                                        accept: ['didcomm/aip2;env=rfc19'],
                                    },
                                    {
                                        id: 'did:indy:pool1:B6xaJg1c2xU3D9ppCtt1CZ#didcomm-messaging-1',
                                        type: 'DIDCommMessaging',
                                        serviceEndpoint: { uri: 'https://example.com/endpoint', routingKeys: ['key-1'], accept: ['didcomm/v2'] },
                                    },
                                ],
                                authentication: ['did:indy:pool1:B6xaJg1c2xU3D9ppCtt1CZ#verkey'],
                                assertionMethod: undefined,
                                keyAgreement: ['did:indy:pool1:B6xaJg1c2xU3D9ppCtt1CZ#key-agreement-1'],
                            },
                            secret: {
                                privateKey: privateKey,
                            },
                        },
                    });
                    return [2 /*return*/];
            }
        });
    }); });
    test('stores the did document', function () { return __awaiter(void 0, void 0, void 0, function () {
        var privateKey, createRegisterDidWriteRequestSpy, registerPublicDidSpy, setEndpointsForDidSpy, saveCalled, saveEvent;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    privateKey = core_1.TypedArrayEncoder.fromString('96213c3d7fc8d4d6754c712fd969598e');
                    createRegisterDidWriteRequestSpy = jest.spyOn(indyVdrIndyDidRegistrar, 'createRegisterDidWriteRequest');
                    // @ts-ignore type check fails because method is private
                    createRegisterDidWriteRequestSpy.mockImplementationOnce(function () { return Promise.resolve(); });
                    registerPublicDidSpy = jest.spyOn(indyVdrIndyDidRegistrar, 'registerPublicDid');
                    // @ts-ignore type check fails because method is private
                    registerPublicDidSpy.mockImplementationOnce(function () { return Promise.resolve(); });
                    setEndpointsForDidSpy = jest.spyOn(indyVdrIndyDidRegistrar, 'setEndpointsForDid');
                    // @ts-ignore type check fails because method is private
                    setEndpointsForDidSpy.mockImplementationOnce(function () { return Promise.resolve(undefined); });
                    saveCalled = jest.fn();
                    eventEmitter.on(core_1.RepositoryEventTypes.RecordSaved, saveCalled);
                    return [4 /*yield*/, indyVdrIndyDidRegistrar.create(agentContext, {
                            method: 'indy',
                            options: {
                                alias: 'Hello',
                                endorserMode: 'internal',
                                endorserDid: 'did:indy:pool1:BzCbsNYhMrjHiqZDTUASHg',
                                role: 'STEWARD',
                                services: [
                                    new core_1.DidDocumentService({
                                        id: "#endpoint",
                                        serviceEndpoint: 'https://example.com/endpoint',
                                        type: 'endpoint',
                                    }),
                                    new core_1.DidCommV1Service({
                                        id: "#did-communication",
                                        priority: 0,
                                        recipientKeys: ["#key-agreement-1"],
                                        routingKeys: ['key-1'],
                                        serviceEndpoint: 'https://example.com/endpoint',
                                        accept: ['didcomm/aip2;env=rfc19'],
                                    }),
                                    new core_1.NewDidCommV2Service({
                                        id: "#didcomm-messaging-1",
                                        serviceEndpoint: new core_1.NewDidCommV2ServiceEndpoint({
                                            accept: ['didcomm/v2'],
                                            routingKeys: ['key-1'],
                                            uri: 'https://example.com/endpoint',
                                        }),
                                    }),
                                ],
                            },
                            secret: {
                                privateKey: privateKey,
                            },
                        })];
                case 1:
                    _a.sent();
                    expect(saveCalled).toHaveBeenCalledTimes(1);
                    saveEvent = saveCalled.mock.calls[0][0];
                    expect(saveEvent.payload.record.getTags()).toMatchObject({
                        recipientKeyFingerprints: ['z6LSrH6AdsQeZuKKmG6Ehx7abEQZsVg2psR2VU536gigUoAe'],
                    });
                    expect(saveEvent.payload.record).toMatchObject({
                        did: 'did:indy:pool1:B6xaJg1c2xU3D9ppCtt1CZ',
                        role: core_1.DidDocumentRole.Created,
                        didDocument: expect.any(core_1.DidDocument),
                    });
                    return [2 /*return*/];
            }
        });
    }); });
    test('returns an error state when calling update', function () { return __awaiter(void 0, void 0, void 0, function () {
        var result;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, indyVdrIndyDidRegistrar.update()];
                case 1:
                    result = _a.sent();
                    expect(result).toEqual({
                        didDocumentMetadata: {},
                        didRegistrationMetadata: {},
                        didState: {
                            state: 'failed',
                            reason: "notImplemented: updating did:indy not implemented yet",
                        },
                    });
                    return [2 /*return*/];
            }
        });
    }); });
    test('returns an error state when calling deactivate', function () { return __awaiter(void 0, void 0, void 0, function () {
        var result;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, indyVdrIndyDidRegistrar.deactivate()];
                case 1:
                    result = _a.sent();
                    expect(result).toEqual({
                        didDocumentMetadata: {},
                        didRegistrationMetadata: {},
                        didState: {
                            state: 'failed',
                            reason: "notImplemented: deactivating did:indy not implemented yet",
                        },
                    });
                    return [2 /*return*/];
            }
        });
    }); });
});
