"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g = Object.create((typeof Iterator === "function" ? Iterator : Object).prototype);
    return g.next = verb(0), g["throw"] = verb(1), g["return"] = verb(2), typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@credo-ts/core");
var parse_1 = require("../../../../core/src/modules/dids/domain/parse");
var helpers_1 = require("../../../../core/tests/helpers");
var IndyVdrPool_1 = require("../../pool/IndyVdrPool");
var IndyVdrPoolService_1 = require("../../pool/IndyVdrPoolService");
var IndyVdrSovDidResolver_1 = require("../IndyVdrSovDidResolver");
var didSovR1xKJw17sUoXhejEpugMYJ_json_1 = require("./__fixtures__/didSovR1xKJw17sUoXhejEpugMYJ.json");
var didSovWJz9mHyW9BZksioQnRsrAo_json_1 = require("./__fixtures__/didSovWJz9mHyW9BZksioQnRsrAo.json");
jest.mock('../../pool/IndyVdrPool');
var IndyVdrPoolMock = IndyVdrPool_1.IndyVdrPool;
var poolMock = new IndyVdrPoolMock();
(0, helpers_1.mockProperty)(poolMock, 'indyNamespace', 'local');
var agentConfig = (0, helpers_1.getAgentConfig)('IndyVdrSovDidResolver');
var agentContext = (0, helpers_1.getAgentContext)({
    agentConfig: agentConfig,
    registerInstances: [[IndyVdrPoolService_1.IndyVdrPoolService, { getPoolForDid: jest.fn().mockReturnValue({ pool: poolMock }) }]],
});
var resolver = new IndyVdrSovDidResolver_1.IndyVdrSovDidResolver();
describe('DidResolver', function () {
    describe('IndyVdrSovDidResolver', function () {
        it('should correctly resolve a did:sov document', function () { return __awaiter(void 0, void 0, void 0, function () {
            var did, nymResponse, attribResponse, result;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        did = 'did:sov:R1xKJw17sUoXhejEpugMYJ';
                        nymResponse = {
                            result: {
                                data: JSON.stringify({
                                    did: 'R1xKJw17sUoXhejEpugMYJ',
                                    verkey: 'E6D1m3eERqCueX4ZgMCY14B4NceAr6XP2HyVqt55gDhu',
                                    role: 'ENDORSER',
                                }),
                            },
                        };
                        attribResponse = {
                            result: {
                                data: JSON.stringify({
                                    endpoint: {
                                        endpoint: 'https://ssi.com',
                                        profile: 'https://profile.com',
                                        hub: 'https://hub.com',
                                    },
                                }),
                            },
                        };
                        jest.spyOn(poolMock, 'submitRequest').mockResolvedValueOnce(nymResponse);
                        jest.spyOn(poolMock, 'submitRequest').mockResolvedValueOnce(attribResponse);
                        return [4 /*yield*/, resolver.resolve(agentContext, did, (0, parse_1.parseDid)(did))];
                    case 1:
                        result = _a.sent();
                        expect(core_1.JsonTransformer.toJSON(result)).toMatchObject({
                            didDocument: didSovR1xKJw17sUoXhejEpugMYJ_json_1.default,
                            didDocumentMetadata: {},
                            didResolutionMetadata: {
                                contentType: 'application/did+ld+json',
                            },
                        });
                        return [2 /*return*/];
                }
            });
        }); });
        it('should resolve a did:sov document with routingKeys and types entries in the attrib', function () { return __awaiter(void 0, void 0, void 0, function () {
            var did, nymResponse, attribResponse, result;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        did = 'did:sov:WJz9mHyW9BZksioQnRsrAo';
                        nymResponse = {
                            result: {
                                data: JSON.stringify({
                                    did: 'WJz9mHyW9BZksioQnRsrAo',
                                    verkey: 'GyYtYWU1vjwd5PFJM4VSX5aUiSV3TyZMuLBJBTQvfdF8',
                                    role: 'ENDORSER',
                                }),
                            },
                        };
                        attribResponse = {
                            result: {
                                data: JSON.stringify({
                                    endpoint: {
                                        endpoint: 'https://agent.com',
                                        types: ['endpoint', 'did-communication', 'DIDComm'],
                                        routingKeys: ['routingKey1', 'routingKey2'],
                                    },
                                }),
                            },
                        };
                        jest.spyOn(poolMock, 'submitRequest').mockResolvedValueOnce(nymResponse);
                        jest.spyOn(poolMock, 'submitRequest').mockResolvedValueOnce(attribResponse);
                        return [4 /*yield*/, resolver.resolve(agentContext, did, (0, parse_1.parseDid)(did))];
                    case 1:
                        result = _a.sent();
                        expect(core_1.JsonTransformer.toJSON(result)).toMatchObject({
                            didDocument: didSovWJz9mHyW9BZksioQnRsrAo_json_1.default,
                            didDocumentMetadata: {},
                            didResolutionMetadata: {
                                contentType: 'application/did+ld+json',
                            },
                        });
                        return [2 /*return*/];
                }
            });
        }); });
        it('should return did resolution metadata with error if the indy ledger service throws an error', function () { return __awaiter(void 0, void 0, void 0, function () {
            var did, result;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        did = 'did:sov:R1xKJw17sUoXhejEpugMYJ';
                        jest.spyOn(poolMock, 'submitRequest').mockRejectedValue(new Error('Error submitting read request'));
                        return [4 /*yield*/, resolver.resolve(agentContext, did, (0, parse_1.parseDid)(did))];
                    case 1:
                        result = _a.sent();
                        expect(result).toMatchObject({
                            didDocument: null,
                            didDocumentMetadata: {},
                            didResolutionMetadata: {
                                error: 'notFound',
                                message: "resolver_error: Unable to resolve did 'did:sov:R1xKJw17sUoXhejEpugMYJ': Error: Error submitting read request",
                            },
                        });
                        return [2 /*return*/];
                }
            });
        }); });
    });
});
