"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g = Object.create((typeof Iterator === "function" ? Iterator : Object).prototype);
    return g.next = verb(0), g["throw"] = verb(1), g["return"] = verb(2), typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.indyDidDocumentFromDid = indyDidDocumentFromDid;
exports.createKeyAgreementKey = createKeyAgreementKey;
exports.combineDidDocumentWithJson = combineDidDocumentWithJson;
exports.didDocDiff = didDocDiff;
exports.isSelfCertifiedIndyDid = isSelfCertifiedIndyDid;
exports.indyDidFromNamespaceAndInitialKey = indyDidFromNamespaceAndInitialKey;
exports.verificationKeyForIndyDid = verificationKeyForIndyDid;
exports.getPublicDid = getPublicDid;
exports.getEndpointsForDid = getEndpointsForDid;
exports.buildDidDocument = buildDidDocument;
var anoncreds_1 = require("@credo-ts/anoncreds");
var core_1 = require("@credo-ts/core");
var indy_vdr_shared_1 = require("@hyperledger/indy-vdr-shared");
var error_1 = require("../error");
var didSovUtil_1 = require("./didSovUtil");
// Create a base DIDDoc template according to https://hyperledger.github.io/indy-did-method/#base-diddoc-template
function indyDidDocumentFromDid(did, verKeyBase58) {
    var verificationMethodId = "".concat(did, "#verkey");
    var publicKeyBase58 = verKeyBase58;
    var builder = new core_1.DidDocumentBuilder(did)
        .addContext('https://w3id.org/security/suites/ed25519-2018/v1')
        .addVerificationMethod({
        controller: did,
        id: verificationMethodId,
        publicKeyBase58: publicKeyBase58,
        type: 'Ed25519VerificationKey2018',
    })
        .addAuthentication(verificationMethodId);
    return builder;
}
function createKeyAgreementKey(verkey) {
    return core_1.TypedArrayEncoder.toBase58((0, core_1.convertPublicKeyToX25519)(core_1.TypedArrayEncoder.fromBase58(verkey)));
}
var deepMerge = function (a, b) {
    var output = {};
    __spreadArray([], new Set(__spreadArray(__spreadArray([], Object.keys(a), true), Object.keys(b), true)), true).forEach(function (key) {
        // Only an object includes a given key: just output it
        if (a[key] && !b[key]) {
            output[key] = a[key];
        }
        else if (!a[key] && b[key]) {
            output[key] = b[key];
        }
        else {
            // Both objects do include the key
            // Some or both are arrays
            if (Array.isArray(a[key])) {
                if (Array.isArray(b[key])) {
                    var element_1 = new Set();
                    a[key].forEach(function (item) { return element_1.add(item); });
                    b[key].forEach(function (item) { return element_1.add(item); });
                    output[key] = Array.from(element_1);
                }
                else {
                    // eslint-disable-next-line @typescript-eslint/no-explicit-any
                    var arr = a[key];
                    output[key] = Array.from(new (Set.bind.apply(Set, __spreadArray(__spreadArray([void 0], arr, false), [b[key]], false)))());
                }
            }
            else if (Array.isArray(b[key])) {
                // eslint-disable-next-line @typescript-eslint/no-explicit-any
                var arr = b[key];
                output[key] = Array.from(new (Set.bind.apply(Set, __spreadArray(__spreadArray([void 0], arr, false), [a[key]], false)))());
                // Both elements are objects: recursive merge
            }
            else if (typeof a[key] == 'object' && typeof b[key] == 'object') {
                output[key] = deepMerge(a, b);
            }
        }
    });
    return output;
};
/**
 * Combine a JSON content with the contents of a DidDocument
 * @param didDoc object containing original DIDDocument
 * @param json object containing extra DIDDoc contents
 *
 * @returns a DidDocument object resulting from the combination of both
 */
function combineDidDocumentWithJson(didDoc, json) {
    var didDocJson = didDoc.toJSON();
    var combinedJson = deepMerge(didDocJson, json);
    return core_1.JsonTransformer.fromJSON(combinedJson, core_1.DidDocument);
}
/**
 * Processes the difference between a base DidDocument and a complete DidDocument
 *
 * Note: it does deep comparison based only on "id" field to determine whether is
 * the same object or is a different one
 *
 * @param extra complete DidDocument
 * @param base base DidDocument
 * @returns diff object
 */
function didDocDiff(extra, base) {
    var output = {};
    for (var key in extra) {
        if (!(key in base)) {
            output[key] = extra[key];
        }
        else {
            // They are arrays: compare elements
            if (Array.isArray(extra[key]) && Array.isArray(base[key])) {
                // Different types: return the extra
                output[key] = [];
                // eslint-disable-next-line @typescript-eslint/no-explicit-any
                var baseAsArray = base[key];
                // eslint-disable-next-line @typescript-eslint/no-explicit-any
                var extraAsArray = extra[key];
                var _loop_1 = function (element) {
                    if (!baseAsArray.find(function (item) { return item.id === element.id; })) {
                        ;
                        output[key].push(element);
                    }
                };
                for (var _i = 0, extraAsArray_1 = extraAsArray; _i < extraAsArray_1.length; _i++) {
                    var element = extraAsArray_1[_i];
                    _loop_1(element);
                }
            } // They are both objects: do recursive diff
            else if (typeof extra[key] == 'object' && typeof base[key] == 'object') {
                output[key] = didDocDiff(extra[key], base[key]);
            }
            else {
                output[key] = extra[key];
            }
        }
    }
    return output;
}
/**
 * Check whether the did is a self certifying did. If the verkey is abbreviated this method
 * will always return true. Make sure that the verkey you pass in this method belongs to the
 * did passed in
 *
 * @return Boolean indicating whether the did is self certifying
 */
function isSelfCertifiedIndyDid(did, verkey) {
    var namespace = (0, anoncreds_1.parseIndyDid)(did).namespace;
    var didFromVerkey = indyDidFromNamespaceAndInitialKey(namespace, core_1.Key.fromPublicKeyBase58(verkey, core_1.KeyType.Ed25519)).did;
    if (didFromVerkey === did) {
        return true;
    }
    return false;
}
function indyDidFromNamespaceAndInitialKey(namespace, initialKey) {
    var buffer = core_1.Hasher.hash(initialKey.publicKey, 'sha-256');
    var id = core_1.TypedArrayEncoder.toBase58(buffer.slice(0, 16));
    var verkey = initialKey.publicKeyBase58;
    var did = "did:indy:".concat(namespace, ":").concat(id);
    return { did: did, id: id, verkey: verkey };
}
/**
 * Fetches the verification key for a given did:indy did and returns the key as a {@link Key} object.
 *
 * @throws {@link CredoError} if the did could not be resolved or the key could not be extracted
 */
function verificationKeyForIndyDid(agentContext, did) {
    return __awaiter(this, void 0, void 0, function () {
        var didsApi, didResult, verificationMethod, key;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    didsApi = agentContext.dependencyManager.resolve(core_1.DidsApi);
                    return [4 /*yield*/, didsApi.resolve(did)];
                case 1:
                    didResult = _a.sent();
                    if (!didResult.didDocument) {
                        throw new core_1.CredoError("Could not resolve did ".concat(did, ". ").concat(didResult.didResolutionMetadata.error, " ").concat(didResult.didResolutionMetadata.message));
                    }
                    verificationMethod = didResult.didDocument.dereferenceKey("".concat(did, "#verkey"));
                    key = (0, core_1.getKeyFromVerificationMethod)(verificationMethod);
                    return [2 /*return*/, key];
            }
        });
    });
}
function getPublicDid(pool, unqualifiedDid) {
    return __awaiter(this, void 0, void 0, function () {
        var request, didResponse;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    request = new indy_vdr_shared_1.GetNymRequest({ dest: unqualifiedDid });
                    return [4 /*yield*/, pool.submitRequest(request)];
                case 1:
                    didResponse = _a.sent();
                    if (!didResponse.result.data) {
                        throw new error_1.IndyVdrNotFoundError("DID ".concat(unqualifiedDid, " not found in indy namespace ").concat(pool.indyNamespace));
                    }
                    return [2 /*return*/, JSON.parse(didResponse.result.data)];
            }
        });
    });
}
function getEndpointsForDid(agentContext, pool, unqualifiedDid) {
    return __awaiter(this, void 0, void 0, function () {
        var request, response, endpoints, error_2;
        var _a;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    _b.trys.push([0, 2, , 3]);
                    agentContext.config.logger.debug("Get endpoints for did '".concat(unqualifiedDid, "' from ledger '").concat(pool.indyNamespace, "'"));
                    request = new indy_vdr_shared_1.GetAttribRequest({ targetDid: unqualifiedDid, raw: 'endpoint' });
                    agentContext.config.logger.debug("Submitting get endpoint ATTRIB request for did '".concat(unqualifiedDid, "' to ledger '").concat(pool.indyNamespace, "'"));
                    return [4 /*yield*/, pool.submitRequest(request)];
                case 1:
                    response = _b.sent();
                    if (!response.result.data) {
                        return [2 /*return*/, null];
                    }
                    endpoints = (_a = JSON.parse(response.result.data)) === null || _a === void 0 ? void 0 : _a.endpoint;
                    agentContext.config.logger.debug("Got endpoints '".concat(JSON.stringify(endpoints), "' for did '").concat(unqualifiedDid, "' from ledger '").concat(pool.indyNamespace, "'"), {
                        response: response,
                        endpoints: endpoints,
                    });
                    return [2 /*return*/, endpoints];
                case 2:
                    error_2 = _b.sent();
                    agentContext.config.logger.error("Error retrieving endpoints for did '".concat(unqualifiedDid, "' from ledger '").concat(pool.indyNamespace, "'"), {
                        error: error_2,
                    });
                    throw new error_1.IndyVdrError(error_2);
                case 3: return [2 /*return*/];
            }
        });
    });
}
function buildDidDocument(agentContext, pool, did) {
    return __awaiter(this, void 0, void 0, function () {
        var namespaceIdentifier, nym, verkey, builder, keyAgreementId, endpoints;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    namespaceIdentifier = (0, anoncreds_1.parseIndyDid)(did).namespaceIdentifier;
                    return [4 /*yield*/, getPublicDid(pool, namespaceIdentifier)
                        // Create base Did Document
                        // For modern did:indy DIDs, we assume that GET_NYM is always a full verkey in base58.
                        // For backwards compatibility, we accept a shortened verkey and convert it using previous convention
                    ];
                case 1:
                    nym = _a.sent();
                    verkey = (0, didSovUtil_1.getFullVerkey)(namespaceIdentifier, nym.verkey);
                    builder = indyDidDocumentFromDid(did, verkey);
                    if (!!nym.diddocContent) return [3 /*break*/, 3];
                    keyAgreementId = "".concat(did, "#key-agreement-1");
                    return [4 /*yield*/, getEndpointsForDid(agentContext, pool, namespaceIdentifier)];
                case 2:
                    endpoints = _a.sent();
                    if (endpoints) {
                        builder
                            .addContext('https://w3id.org/security/suites/x25519-2019/v1')
                            .addVerificationMethod({
                            controller: did,
                            id: keyAgreementId,
                            publicKeyBase58: createKeyAgreementKey(verkey),
                            type: 'X25519KeyAgreementKey2019',
                        })
                            .addKeyAgreement(keyAgreementId);
                        // Process endpoint attrib following the same rules as for did:sov
                        (0, didSovUtil_1.addServicesFromEndpointsAttrib)(builder, did, endpoints, keyAgreementId);
                    }
                    return [2 /*return*/, builder.build()];
                case 3: 
                // Combine it with didDoc (TODO: Check if diddocContent is returned as a JSON object or a string)
                return [2 /*return*/, combineDidDocumentWithJson(builder.build(), nym.diddocContent)];
            }
        });
    });
}
