"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g = Object.create((typeof Iterator === "function" ? Iterator : Object).prototype);
    return g.next = verb(0), g["throw"] = verb(1), g["return"] = verb(2), typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.IndyVdrPool = void 0;
var anoncreds_1 = require("@credo-ts/anoncreds");
var core_1 = require("@credo-ts/core");
var indy_vdr_shared_1 = require("@hyperledger/indy-vdr-shared");
var error_1 = require("../error");
var IndyVdrPool = /** @class */ (function () {
    function IndyVdrPool(poolConfig) {
        this.poolConfig = poolConfig;
    }
    Object.defineProperty(IndyVdrPool.prototype, "indyNamespace", {
        get: function () {
            return this.poolConfig.indyNamespace;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IndyVdrPool.prototype, "config", {
        get: function () {
            return this.poolConfig;
        },
        enumerable: false,
        configurable: true
    });
    IndyVdrPool.prototype.connect = function () {
        if (this._pool) {
            throw new error_1.IndyVdrError('Cannot connect to pool, already connected.');
        }
        this._pool = new indy_vdr_shared_1.PoolCreate({
            parameters: {
                transactions: this.config.genesisTransactions,
            },
        });
    };
    /**
     * Refreshes the connection to the pool.
     */
    IndyVdrPool.prototype.refreshConnection = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!this._pool) return [3 /*break*/, 2];
                        return [4 /*yield*/, this._pool.refresh()];
                    case 1:
                        _a.sent();
                        _a.label = 2;
                    case 2: return [2 /*return*/];
                }
            });
        });
    };
    Object.defineProperty(IndyVdrPool.prototype, "transactions", {
        /**
         * Get the transactions for a pool
         */
        get: function () {
            return this.pool.transactions;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IndyVdrPool.prototype, "pool", {
        get: function () {
            if (!this._pool)
                this.connect();
            if (!this._pool)
                throw new error_1.IndyVdrError('Pool is not connected.');
            return this._pool;
        },
        enumerable: false,
        configurable: true
    });
    IndyVdrPool.prototype.close = function () {
        if (!this._pool) {
            throw new error_1.IndyVdrError("Can't close pool. Pool is not connected");
        }
        // FIXME: this method doesn't work??
        // this.pool.close()
    };
    IndyVdrPool.prototype.prepareWriteRequest = function (agentContext, request, signingKey, endorserDid) {
        return __awaiter(this, void 0, void 0, function () {
            var signature;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.appendTaa(request)];
                    case 1:
                        _a.sent();
                        if (endorserDid) {
                            request.setEndorser({ endorser: (0, anoncreds_1.parseIndyDid)(endorserDid).namespaceIdentifier });
                        }
                        return [4 /*yield*/, agentContext.wallet.sign({
                                data: core_1.TypedArrayEncoder.fromString(request.signatureInput),
                                key: signingKey,
                            })];
                    case 2:
                        signature = _a.sent();
                        request.setSignature({
                            signature: signature,
                        });
                        return [2 /*return*/, request];
                }
            });
        });
    };
    /**
     * This method submits a request to the ledger.
     * It does only submit the request. It does not modify it in any way.
     * To create the request, use the `prepareWriteRequest` method.
     * @param writeRequest
     */
    IndyVdrPool.prototype.submitRequest = function (writeRequest) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.pool.submitRequest(writeRequest)];
                    case 1: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    IndyVdrPool.prototype.appendTaa = function (request) {
        return __awaiter(this, void 0, void 0, function () {
            var authorAgreement, poolTaa, errMessage, acceptance;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.getTransactionAuthorAgreement()];
                    case 1:
                        authorAgreement = _a.sent();
                        poolTaa = this.config.transactionAuthorAgreement;
                        // If ledger does not have TAA, we can just send request
                        if (authorAgreement == null) {
                            return [2 /*return*/, request];
                        }
                        // Ledger has taa but user has not specified which one to use
                        if (!poolTaa) {
                            throw new error_1.IndyVdrError("Please, specify a transaction author agreement with version and acceptance mechanism. ".concat(JSON.stringify(authorAgreement)));
                        }
                        // Throw an error if the pool doesn't have the specified version and acceptance mechanism
                        if (authorAgreement.version !== poolTaa.version ||
                            !authorAgreement.acceptanceMechanisms.aml[poolTaa.acceptanceMechanism]) {
                            errMessage = "Unable to satisfy matching TAA with mechanism ".concat(JSON.stringify(poolTaa.acceptanceMechanism), " and version ").concat(poolTaa.version, " in pool.\n Found ").concat(JSON.stringify(authorAgreement.acceptanceMechanisms.aml), " and version ").concat(authorAgreement.version, " in pool.");
                            throw new error_1.IndyVdrError(errMessage);
                        }
                        acceptance = indy_vdr_shared_1.indyVdr.prepareTxnAuthorAgreementAcceptance({
                            text: authorAgreement.text,
                            version: authorAgreement.version,
                            taaDigest: authorAgreement.digest,
                            time: Math.floor(new Date().getTime() / 1000),
                            acceptanceMechanismType: poolTaa.acceptanceMechanism,
                        });
                        request.setTransactionAuthorAgreementAcceptance({
                            acceptance: JSON.parse(acceptance),
                        });
                        return [2 /*return*/];
                }
            });
        });
    };
    IndyVdrPool.prototype.getTransactionAuthorAgreement = function () {
        return __awaiter(this, void 0, void 0, function () {
            var taaRequest, taaResponse, acceptanceMechanismRequest, acceptanceMechanismResponse, taaData, authorAgreement, acceptanceMechanisms;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        // TODO Replace this condition with memoization
                        if (this.authorAgreement !== undefined) {
                            return [2 /*return*/, this.authorAgreement];
                        }
                        taaRequest = new indy_vdr_shared_1.GetTransactionAuthorAgreementRequest({});
                        return [4 /*yield*/, this.submitRequest(taaRequest)];
                    case 1:
                        taaResponse = _a.sent();
                        acceptanceMechanismRequest = new indy_vdr_shared_1.GetAcceptanceMechanismsRequest({});
                        return [4 /*yield*/, this.submitRequest(acceptanceMechanismRequest)];
                    case 2:
                        acceptanceMechanismResponse = _a.sent();
                        taaData = taaResponse.result.data;
                        // TAA can be null
                        if (taaData == null) {
                            this.authorAgreement = null;
                            return [2 /*return*/, null];
                        }
                        authorAgreement = taaData;
                        acceptanceMechanisms = acceptanceMechanismResponse.result.data;
                        this.authorAgreement = __assign(__assign({}, authorAgreement), { acceptanceMechanisms: acceptanceMechanisms });
                        return [2 /*return*/, this.authorAgreement];
                }
            });
        });
    };
    return IndyVdrPool;
}());
exports.IndyVdrPool = IndyVdrPool;
