"use strict";
var __esDecorate = (this && this.__esDecorate) || function (ctor, descriptorIn, decorators, contextIn, initializers, extraInitializers) {
    function accept(f) { if (f !== void 0 && typeof f !== "function") throw new TypeError("Function expected"); return f; }
    var kind = contextIn.kind, key = kind === "getter" ? "get" : kind === "setter" ? "set" : "value";
    var target = !descriptorIn && ctor ? contextIn["static"] ? ctor : ctor.prototype : null;
    var descriptor = descriptorIn || (target ? Object.getOwnPropertyDescriptor(target, contextIn.name) : {});
    var _, done = false;
    for (var i = decorators.length - 1; i >= 0; i--) {
        var context = {};
        for (var p in contextIn) context[p] = p === "access" ? {} : contextIn[p];
        for (var p in contextIn.access) context.access[p] = contextIn.access[p];
        context.addInitializer = function (f) { if (done) throw new TypeError("Cannot add initializers after decoration has completed"); extraInitializers.push(accept(f || null)); };
        var result = (0, decorators[i])(kind === "accessor" ? { get: descriptor.get, set: descriptor.set } : descriptor[key], context);
        if (kind === "accessor") {
            if (result === void 0) continue;
            if (result === null || typeof result !== "object") throw new TypeError("Object expected");
            if (_ = accept(result.get)) descriptor.get = _;
            if (_ = accept(result.set)) descriptor.set = _;
            if (_ = accept(result.init)) initializers.unshift(_);
        }
        else if (_ = accept(result)) {
            if (kind === "field") initializers.unshift(_);
            else descriptor[key] = _;
        }
    }
    if (target) Object.defineProperty(target, contextIn.name, descriptor);
    done = true;
};
var __runInitializers = (this && this.__runInitializers) || function (thisArg, initializers, value) {
    var useValue = arguments.length > 2;
    for (var i = 0; i < initializers.length; i++) {
        value = useValue ? initializers[i].call(thisArg, value) : initializers[i].call(thisArg);
    }
    return useValue ? value : void 0;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g = Object.create((typeof Iterator === "function" ? Iterator : Object).prototype);
    return g.next = verb(0), g["throw"] = verb(1), g["return"] = verb(2), typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __setFunctionName = (this && this.__setFunctionName) || function (f, name, prefix) {
    if (typeof name === "symbol") name = name.description ? "[".concat(name.description, "]") : "";
    return Object.defineProperty(f, "name", { configurable: true, value: prefix ? "".concat(prefix, " ", name) : name });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.IndyVdrPoolService = void 0;
var anoncreds_1 = require("@credo-ts/anoncreds");
var core_1 = require("@credo-ts/core");
var indy_vdr_shared_1 = require("@hyperledger/indy-vdr-shared");
var error_1 = require("../error");
var did_1 = require("../utils/did");
var promises_1 = require("../utils/promises");
var IndyVdrPool_1 = require("./IndyVdrPool");
var IndyVdrPoolService = function () {
    var _classDecorators = [(0, core_1.injectable)()];
    var _classDescriptor;
    var _classExtraInitializers = [];
    var _classThis;
    var IndyVdrPoolService = _classThis = /** @class */ (function () {
        function IndyVdrPoolService_1(logger, indyVdrModuleConfig) {
            this.pools = [];
            this.logger = logger;
            this.indyVdrModuleConfig = indyVdrModuleConfig;
            this.pools = this.indyVdrModuleConfig.networks.map(function (poolConfig) { return new IndyVdrPool_1.IndyVdrPool(poolConfig); });
        }
        /**
         * Get the most appropriate pool for the given did.
         * If the did is a qualified indy did, the pool will be determined based on the namespace.
         * If it is a legacy unqualified indy did, the pool will be determined based on the algorithm as described in this document:
         * https://docs.google.com/document/d/109C_eMsuZnTnYe2OAd02jAts1vC4axwEKIq7_4dnNVA/edit
         *
         * This method will optionally return a nym response when the did has been resolved to determine the ledger
         * either now or in the past. The nymResponse can be used to prevent multiple ledger quries fetching the same
         * did
         */
        IndyVdrPoolService_1.prototype.getPoolForDid = function (agentContext, did) {
            return __awaiter(this, void 0, void 0, function () {
                var match, namespace, pool;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            match = did.match(anoncreds_1.didIndyRegex);
                            if (!match) return [3 /*break*/, 1];
                            namespace = match[1];
                            pool = this.getPoolForNamespace(namespace);
                            if (pool)
                                return [2 /*return*/, { pool: pool }];
                            throw new error_1.IndyVdrError("Pool for indy namespace '".concat(namespace, "' not found"));
                        case 1: return [4 /*yield*/, this.getPoolForLegacyDid(agentContext, did)];
                        case 2: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        IndyVdrPoolService_1.prototype.getPoolForLegacyDid = function (agentContext, did) {
            return __awaiter(this, void 0, void 0, function () {
                var pools, cache, cacheKey, cachedNymResponse, pool, _a, successful, rejected, allNotFound, rejectedOtherThanNotFound, value, production, nonProduction, productionOrNonProduction;
                var _b;
                return __generator(this, function (_c) {
                    switch (_c.label) {
                        case 0:
                            pools = this.pools;
                            if (pools.length === 0) {
                                throw new error_1.IndyVdrNotConfiguredError('No indy ledgers configured. Provide at least one pool configuration in IndyVdrModuleConfigOptions.networks');
                            }
                            cache = agentContext.dependencyManager.resolve(core_1.CacheModuleConfig).cache;
                            cacheKey = "IndyVdrPoolService:".concat(did);
                            return [4 /*yield*/, cache.get(agentContext, cacheKey)];
                        case 1:
                            cachedNymResponse = _c.sent();
                            pool = this.pools.find(function (pool) { return pool.indyNamespace === (cachedNymResponse === null || cachedNymResponse === void 0 ? void 0 : cachedNymResponse.indyNamespace); });
                            // If we have the nym response with associated pool in the cache, we'll use that
                            if (cachedNymResponse && pool) {
                                this.logger.trace("Found ledger id '".concat(pool.indyNamespace, "' for did '").concat(did, "' in cache"));
                                return [2 /*return*/, { pool: pool, nymResponse: cachedNymResponse.nymResponse }];
                            }
                            return [4 /*yield*/, this.getSettledDidResponsesFromPools(did, pools)];
                        case 2:
                            _a = _c.sent(), successful = _a.successful, rejected = _a.rejected;
                            if (successful.length === 0) {
                                allNotFound = rejected.every(function (e) { return e.reason instanceof error_1.IndyVdrNotFoundError; });
                                rejectedOtherThanNotFound = rejected.filter(function (e) { return !(e.reason instanceof error_1.IndyVdrNotFoundError); });
                                // All ledgers returned response that the did was not found
                                if (allNotFound) {
                                    throw new error_1.IndyVdrNotFoundError("Did '".concat(did, "' not found on any of the ledgers (total ").concat(this.pools.length, ")."));
                                }
                                // one or more of the ledgers returned an unknown error
                                throw new error_1.IndyVdrError("Unknown error retrieving did '".concat(did, "' from '").concat(rejectedOtherThanNotFound.length, "' of '").concat(pools.length, "' ledgers. ").concat(rejectedOtherThanNotFound[0].reason), { cause: rejectedOtherThanNotFound[0].reason });
                            }
                            value = (_b = successful.find(function (response) {
                                return (0, did_1.isSelfCertifiedDid)(response.value.did.nymResponse.did, response.value.did.nymResponse.verkey);
                            })) === null || _b === void 0 ? void 0 : _b.value;
                            if (!value) {
                                production = successful.filter(function (s) { return s.value.pool.config.isProduction; });
                                nonProduction = successful.filter(function (s) { return !s.value.pool.config.isProduction; });
                                productionOrNonProduction = production.length >= 1 ? production : nonProduction;
                                // We take the first value as we take the order in the IndyVdrModuleConfigOptions.networks
                                // config as the order of preference of ledgers
                                value = productionOrNonProduction[0].value;
                            }
                            return [4 /*yield*/, cache.set(agentContext, cacheKey, {
                                    nymResponse: {
                                        did: value.did.nymResponse.did,
                                        verkey: value.did.nymResponse.verkey,
                                    },
                                    indyNamespace: value.did.indyNamespace,
                                })];
                        case 3:
                            _c.sent();
                            return [2 /*return*/, { pool: value.pool, nymResponse: value.did.nymResponse }];
                    }
                });
            });
        };
        IndyVdrPoolService_1.prototype.getSettledDidResponsesFromPools = function (did, pools) {
            return __awaiter(this, void 0, void 0, function () {
                var didResponses, successful, rejected;
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            this.logger.trace("Retrieving did '".concat(did, "' from ").concat(pools.length, " ledgers"));
                            return [4 /*yield*/, (0, promises_1.allSettled)(pools.map(function (pool) { return _this.getDidFromPool(did, pool); }))];
                        case 1:
                            didResponses = _a.sent();
                            successful = (0, promises_1.onlyFulfilled)(didResponses);
                            this.logger.trace("Retrieved ".concat(successful.length, " responses from ledgers for did '").concat(did, "'"));
                            rejected = (0, promises_1.onlyRejected)(didResponses);
                            return [2 /*return*/, {
                                    rejected: rejected,
                                    successful: successful,
                                }];
                    }
                });
            });
        };
        /**
         * Refresh the pool connections asynchronously
         */
        IndyVdrPoolService_1.prototype.refreshPoolConnections = function () {
            return Promise.allSettled(this.pools.map(function (pool) { return pool.refreshConnection(); }));
        };
        /**
         * Get all pool transactions
         */
        IndyVdrPoolService_1.prototype.getAllPoolTransactions = function () {
            var _this = this;
            return Promise.allSettled(this.pools.map(function (pool) { return __awaiter(_this, void 0, void 0, function () {
                var _a;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            _a = { config: pool.config };
                            return [4 /*yield*/, pool.transactions];
                        case 1: return [2 /*return*/, (_a.transactions = _b.sent(), _a)];
                    }
                });
            }); }));
        };
        /**
         * Get the most appropriate pool for the given indyNamespace
         */
        IndyVdrPoolService_1.prototype.getPoolForNamespace = function (indyNamespace) {
            if (this.pools.length === 0) {
                throw new error_1.IndyVdrNotConfiguredError('No indy ledgers configured. Provide at least one pool configuration in IndyVdrModuleConfigOptions.networks');
            }
            var pool = this.pools.find(function (pool) { return pool.indyNamespace === indyNamespace; });
            if (!pool) {
                throw new error_1.IndyVdrError("No ledgers found for indy namespace '".concat(indyNamespace, "'."));
            }
            return pool;
        };
        IndyVdrPoolService_1.prototype.getDidFromPool = function (did, pool) {
            return __awaiter(this, void 0, void 0, function () {
                var request, response, result, error_2;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            _a.trys.push([0, 2, , 3]);
                            this.logger.trace("Get public did '".concat(did, "' from ledger '").concat(pool.indyNamespace, "'"));
                            request = new indy_vdr_shared_1.GetNymRequest({ dest: did });
                            this.logger.trace("Submitting get did request for did '".concat(did, "' to ledger '").concat(pool.indyNamespace, "'"));
                            return [4 /*yield*/, pool.submitRequest(request)];
                        case 1:
                            response = _a.sent();
                            if (!response.result.data) {
                                throw new error_1.IndyVdrNotFoundError("Did ".concat(did, " not found on indy pool with namespace ").concat(pool.indyNamespace));
                            }
                            result = JSON.parse(response.result.data);
                            this.logger.trace("Retrieved did '".concat(did, "' from ledger '").concat(pool.indyNamespace, "'"), result);
                            return [2 /*return*/, {
                                    did: { nymResponse: { did: result.dest, verkey: result.verkey }, indyNamespace: pool.indyNamespace },
                                    pool: pool,
                                    response: response,
                                }];
                        case 2:
                            error_2 = _a.sent();
                            this.logger.trace("Error retrieving did '".concat(did, "' from ledger '").concat(pool.indyNamespace, "'"), {
                                error: error_2,
                                did: did,
                            });
                            throw error_2;
                        case 3: return [2 /*return*/];
                    }
                });
            });
        };
        return IndyVdrPoolService_1;
    }());
    __setFunctionName(_classThis, "IndyVdrPoolService");
    (function () {
        var _metadata = typeof Symbol === "function" && Symbol.metadata ? Object.create(null) : void 0;
        __esDecorate(null, _classDescriptor = { value: _classThis }, _classDecorators, { kind: "class", name: _classThis.name, metadata: _metadata }, null, _classExtraInitializers);
        IndyVdrPoolService = _classThis = _classDescriptor.value;
        if (_metadata) Object.defineProperty(_classThis, Symbol.metadata, { enumerable: true, configurable: true, writable: true, value: _metadata });
        __runInitializers(_classThis, _classExtraInitializers);
    })();
    return IndyVdrPoolService = _classThis;
}();
exports.IndyVdrPoolService = IndyVdrPoolService;
