"use strict";
// This file polyfills the allSettled method introduced in ESNext
Object.defineProperty(exports, "__esModule", { value: true });
exports.allSettled = allSettled;
exports.onlyFulfilled = onlyFulfilled;
exports.onlyRejected = onlyRejected;
function allSettled(promises) {
    return Promise.all(promises.map(function (p) {
        return p
            .then(function (value) {
            return ({
                status: 'fulfilled',
                value: value,
            });
        })
            .catch(function (reason) {
            return ({
                status: 'rejected',
                reason: reason,
            });
        });
    }));
}
function onlyFulfilled(entries) {
    // We filter for only the rejected values, so we can safely cast the type
    return entries.filter(function (e) { return e.status === 'fulfilled'; });
}
function onlyRejected(entries) {
    // We filter for only the rejected values, so we can safely cast the type
    return entries.filter(function (e) { return e.status === 'rejected'; });
}
